//
//  PreTestChapterController.swift
//  PER
//
//  Created by Conrado on 25/01/2020.
//  Copyright © 2020 Conrado. All rights reserved.
//

import UIKit

class PreTestChapterController : UIViewController {
    
    // Cabecera de presentación
    @IBOutlet weak var viewPresentation: UIView!
    @IBOutlet weak var labelTitle: UILabel!
    @IBOutlet weak var labelConfigTest: UILabel!
    
    // Bloque de número de preguntas
    @IBOutlet weak var viewNumberQuestions: UIView!
    @IBOutlet weak var labelNumberQuestions: UILabel!
    @IBOutlet weak var labelOfficNumberQuestions: UILabel!
    @IBOutlet weak var sliderNumberQuestions: UISlider!
    
    // Bloque de la dificultad
    @IBOutlet weak var viewDifficulty: UIView!
    @IBOutlet weak var labelDifficulty: UILabel!
    @IBOutlet weak var segmentedControlDifficulty: UISegmentedControl!
    @IBOutlet weak var labelDifficultyExplanation: UILabel!

    // Bloque de corrección en tiempo real
    @IBOutlet weak var viewRealTimeCorrect: UIView!
    @IBOutlet weak var labelRealTimeCorrect: UILabel!
    @IBOutlet weak var switchRealTimeCorrect: UISwitch!
    
    // Bloque de guardar como configuración predeterminada
    @IBOutlet weak var viewConfigPredet: UIView!
    @IBOutlet weak var labelConfigPredet: UILabel!
    @IBOutlet weak var switchConfigPredet: UISwitch!
    
    // Bloque del botón para comenzar el test
    @IBOutlet weak var buttonStartTest: UIButton!
    
    
    // Tamaño de pantalla
    var realHeightScreen : CGFloat!
    var realWidthScreen : CGFloat!
    var initialPoint : CGFloat!
    var endPoint : CGFloat!
    var statusBarHeight : CGFloat!
    var navBarHeight : CGFloat!
    var tabBarHeight : CGFloat!
    var widthView : CGFloat!
    var marginLatElement : CGFloat!
    
    
    
    override func viewDidLoad() {
        super.viewDidLoad()

        // Se asigna el diseño de la barra de navegación
        setDesignNavBar(navigationItem: navigationItem, appearance: UINavigationBarAppearance())
        navigationItem.title = "Tema 1"
        let backButton = UIBarButtonItem()
        backButton.title = ""
        self.navigationController?.navigationBar.topItem?.backBarButtonItem = backButton
        self.navigationController?.navigationBar.topItem?.backBarButtonItem?.tintColor = UIColor.white
        
        // - - - - - - - - - - - -
            InitialAndEndPoint ()
        // - - - - - - - - - - - -
        
        widthView = realWidthScreen * 0.96
        marginLatElement = widthView * 0.03
        
        // Asignación forzosa para que pueda coger bien los valores
        viewPresentation.frame = CGRect (x: 0, y: initialPoint, width: realWidthScreen, height: 137)

        labelConfigTest.layer.masksToBounds = true
        labelConfigTest.layer.cornerRadius = 10.0
            
        PositionElementsViewNumberQuestions ()
        PositionElementsViewDifficulty()
        PositionElementsViewRealTimeCorrect ()
        PositionElementsViewConfigPredet ()
        PositionView (currentElement: buttonStartTest, lastElement: viewConfigPredet, heightView: realHeightScreen * 0.18)
        
    
        
    }
    
    
    
    

    
    
    
    
    
    
    
    
    
    
    
    
    
    // Sacar como parámetro exterior el margen inferior
    
    
    func PositionView (currentElement : UIView, lastElement : UIView, heightView : CGFloat) {
        
        let marginLat = realWidthScreen * 0.02
        let marginInf = realHeightScreen * 0.04
        
        currentElement.frame = CGRect (
            x: marginLat,
            y: lastElement.frame.origin.y + lastElement.frame.size.height + marginInf,
            width: widthView,
            height: heightView
        )
        currentElement.layer.masksToBounds = true
        currentElement.layer.cornerRadius = 10
                
    }
    
    
    func PositionElementsViewNumberQuestions () {
        
        // Variables
        let heightView = realHeightScreen * 0.13
        
        // Posicionamiento de la vista principal
        PositionView (currentElement: viewNumberQuestions, lastElement: viewPresentation, heightView: heightView)
        
        // Eliminación de las constraints de autolayout
        labelNumberQuestions.translatesAutoresizingMaskIntoConstraints = false
        labelOfficNumberQuestions.translatesAutoresizingMaskIntoConstraints = false
        sliderNumberQuestions.translatesAutoresizingMaskIntoConstraints = false
        
        // Constraints de la etiqueta
        labelNumberQuestions.leadingAnchor.constraint(equalTo: viewNumberQuestions.leadingAnchor, constant: marginLatElement).isActive = true
        labelNumberQuestions.widthAnchor.constraint(equalToConstant: widthView * 0.72).isActive = true
        labelNumberQuestions.topAnchor.constraint(equalTo: viewNumberQuestions.topAnchor).isActive = true
        labelNumberQuestions.heightAnchor.constraint(equalToConstant: heightView/2).isActive = true
        
        // Constraints de la etiqueta indicando el número
        labelOfficNumberQuestions.rightAnchor.constraint(equalTo: viewNumberQuestions.rightAnchor, constant: -marginLatElement).isActive = true
        labelOfficNumberQuestions.widthAnchor.constraint(equalToConstant: widthView * 0.22).isActive = true
        labelOfficNumberQuestions.topAnchor.constraint(equalTo: viewNumberQuestions.topAnchor).isActive = true
        labelOfficNumberQuestions.heightAnchor.constraint(equalToConstant: heightView/2).isActive = true
        
        // Constraints del slider
        sliderNumberQuestions.leadingAnchor.constraint(equalTo: viewNumberQuestions.leadingAnchor, constant: marginLatElement).isActive = true
        sliderNumberQuestions.rightAnchor.constraint(equalTo: viewNumberQuestions.rightAnchor, constant: -marginLatElement).isActive = true
        sliderNumberQuestions.bottomAnchor.constraint(equalTo: viewNumberQuestions.bottomAnchor).isActive = true
        sliderNumberQuestions.heightAnchor.constraint(equalToConstant: heightView/2).isActive = true
        
        // Diseño de elementos
        // viewNumberQuestions.layer.borderWidth = 1
        // viewNumberQuestions.layer.borderColor = UIColor.orange.cgColor
        // labelNumberQuestions.backgroundColor = .red
        // sliderNumberQuestions.backgroundColor = .yellow
    }
    
    
    func PositionElementsViewDifficulty () {
        
        // Variables
        let heightView = realHeightScreen * 0.15
        let heightView2 = heightView / 2
        let heightSC = segmentedControlDifficulty.frame.size.height
        let marginSC = (heightView2 - heightSC) / 2
        
        // Posicionamiento de la vista principal
        PositionView (currentElement: viewDifficulty, lastElement: viewNumberQuestions, heightView: heightView)
        
        // Eliminación de las constraints de autolayout
        labelDifficulty.translatesAutoresizingMaskIntoConstraints = false
        segmentedControlDifficulty.translatesAutoresizingMaskIntoConstraints = false
        
        // Constraints de la etiqueta
        labelDifficulty.leadingAnchor.constraint(equalTo: viewDifficulty.leadingAnchor, constant: marginLatElement).isActive = true
        labelDifficulty.rightAnchor.constraint(equalTo: viewDifficulty.rightAnchor, constant: -marginLatElement).isActive = true
        labelDifficulty.topAnchor.constraint(equalTo: viewDifficulty.topAnchor).isActive = true
        labelDifficulty.heightAnchor.constraint(equalToConstant: heightView/2).isActive = true
        
        // Constraints de segmented control
        segmentedControlDifficulty.leadingAnchor.constraint(equalTo: viewDifficulty.leadingAnchor, constant: marginLatElement).isActive = true
        segmentedControlDifficulty.rightAnchor.constraint(equalTo: viewDifficulty.rightAnchor, constant: -marginLatElement).isActive = true
        segmentedControlDifficulty.bottomAnchor.constraint(equalTo: viewDifficulty.bottomAnchor, constant: -marginSC*1.5).isActive = true
        
        // Diseño de elementos
        // viewDifficulty.layer.borderWidth = 1
        // viewDifficulty.layer.borderColor = UIColor.orange.cgColor
        // labelDifficulty.backgroundColor = .red
        // segmentedControlDifficulty.backgroundColor = .yellow
    }
    
    
    func PositionElementsViewRealTimeCorrect () {
        
        // Variables
        let heightView = realHeightScreen * 0.14
        let widthLabel = widthView * 0.8
        
        // Posicionamiento de la vista principal
        PositionView (currentElement: viewRealTimeCorrect, lastElement: viewDifficulty, heightView: heightView)
        
        // Eliminación de las constraints de autolayout
        labelRealTimeCorrect.translatesAutoresizingMaskIntoConstraints = false
        switchRealTimeCorrect.translatesAutoresizingMaskIntoConstraints = false
        
        // Constraints de la etiqueta
        labelRealTimeCorrect.leadingAnchor.constraint(equalTo: viewRealTimeCorrect.leadingAnchor, constant: marginLatElement).isActive = true
        labelRealTimeCorrect.widthAnchor.constraint(equalToConstant: widthLabel - marginLatElement).isActive = true
        labelRealTimeCorrect.topAnchor.constraint(equalTo: viewRealTimeCorrect.topAnchor).isActive = true
        labelRealTimeCorrect.heightAnchor.constraint(equalToConstant: heightView).isActive = true
        
        // Constraints del switch
        switchRealTimeCorrect.rightAnchor.constraint(equalTo: viewRealTimeCorrect.rightAnchor, constant: -marginLatElement).isActive = true
        switchRealTimeCorrect.centerYAnchor.constraint(equalTo: viewRealTimeCorrect.centerYAnchor).isActive = true

        // Diseño de elementos
        // viewRealTimeCorrect.layer.borderWidth = 1
        // viewRealTimeCorrect.layer.borderColor = UIColor.orange.cgColor
        // labelRealTimeCorrect.backgroundColor = .red
        // switchRealTimeCorrect.backgroundColor = .yellow
    }
    
    
    func PositionElementsViewConfigPredet () {
        
        // Variables
        let heightView = realHeightScreen * 0.14
        let widthLabel = widthView * 0.8
        
        // Posicionamiento de la vista principal
        PositionView (currentElement: viewConfigPredet, lastElement: viewRealTimeCorrect, heightView: heightView)

        // Eliminación de las constraints de autolayout
        labelConfigPredet.translatesAutoresizingMaskIntoConstraints = false
        switchConfigPredet.translatesAutoresizingMaskIntoConstraints = false
        
        // Constraints de la etiqueta
        labelConfigPredet.leadingAnchor.constraint(equalTo: viewConfigPredet.leadingAnchor, constant: marginLatElement).isActive = true
        labelConfigPredet.widthAnchor.constraint(equalToConstant: widthLabel - marginLatElement).isActive = true
        labelConfigPredet.topAnchor.constraint(equalTo: viewConfigPredet.topAnchor).isActive = true
        labelConfigPredet.heightAnchor.constraint(equalToConstant: heightView).isActive = true
        
        // Constraints del switch
        switchConfigPredet.rightAnchor.constraint(equalTo: viewConfigPredet.rightAnchor, constant: -marginLatElement).isActive = true
        switchConfigPredet.centerYAnchor.constraint(equalTo: viewConfigPredet.centerYAnchor).isActive = true

        // Diseño de elementos
        // labelConfigPredet.backgroundColor = .red
        // switchConfigPredet.backgroundColor = .yellow
    }
    
    
    
    
    
    
    
    
    
    
    
    func InitialAndEndPoint () {
        // height of common elements: statusBar, navBar
        statusBarHeight = getStatusBarHeight()
        navBarHeight = getNavBarHeight(navigationController: self.navigationController!)
        tabBarHeight = getTabBarHeight(tabBarController: self.tabBarController!)
        // real height and real width of screen
        realHeightScreen = fullHeightScreen - statusBarHeight - navBarHeight - tabBarHeight - 137
        realWidthScreen = fullWidthScreen
        // initial point and end point of screen
        initialPoint = getTopBarHeight(statusBarHeight: statusBarHeight, navBarHeight: navBarHeight)
        endPoint = fullHeightScreen - tabBarHeight
    }
    
    
    
    
    
    
    @IBAction func sliderNumberQuestions(_ sender: UISlider) {  }
    @IBAction func segmentedControlDifficulty(_ sender: UISegmentedControl) {  }
    @IBAction func instantCorrectSwitch(_ sender: UISwitch) {  }
    @IBAction func savePredetConfSwitch(_ sender: UISwitch) {  }
}




