//
//  TestController.swift
//  PER
//
//  Created by Conrado on 27/01/2020.
//  Copyright © 2020 Conrado. All rights reserved.
//

import UIKit
import SQLite
import FirebaseDatabase


class TestController: UIViewController {

    // Botón de finalizar el test
    @IBOutlet weak var finishTest: UIBarButtonItem!
    
    // Botones de las respuestas
    @IBOutlet weak var firstAnswerButton: UIButton!
    @IBOutlet weak var secondAnswerButton: UIButton!
    @IBOutlet weak var thirdAnswerButton: UIButton!
    @IBOutlet weak var fourthAnswerButton: UIButton!
    
    // Botones de atras y adelante en las preguntas
    @IBOutlet weak var lastQuestionButton: UIButton!
    @IBOutlet weak var nextQuestionButton: UIButton!
    
    // Etiqueta para el cronómetro
    @IBOutlet weak var chronometerLabel: UILabel!
    
    // Botón de obtener una pista
    @IBOutlet weak var getClueButton: UIButton!
    
    // Variables para obtener las condiciones de la pantalla anterior
    var totalNumberOfQuestions : Int!
    var difficulty : Int!
    var timer : Bool!
    var clue : Bool!
    var instantCorrection : Bool!
    var savePredetConfiguration : Bool!
    
    
    let screenSize = UIScreen.main.bounds
    let screenWidth = UIScreen.main.bounds.width
    let screenHeight = UIScreen.main.bounds.height
    var imageViewBackgroundQuestion = UIImageView()
    let labelQuestion = UILabel()
    
    // var randomNumbers : [Int] = []
    // var numberQuestionsOfChapter : Int = 0
    // var questionsTest : [Question] = []
    

    override func viewDidLoad() {
        super.viewDidLoad()
        
        /*
            print (" ===================== VALORES RECIBIDOS: ")
            print (" Número total de preguntas: \(self.totalNumberOfQuestions)")
            print (" Dificultad: \(self.difficulty)")
            print (" Contador de tiempo: \(self.timer)")
            print (" Posibilidad de pista: \(self.clue)")
            print (" Corrección instantánea: \(self.instantCorrection)")
            print (" Guardar configuración predeterminada: \(self.savePredetConfiguration)")
            print (" ======================================= ")
        */
 
        let attributes: [NSAttributedString.Key : Any] = [ .font: UIFont.boldSystemFont(ofSize: 22) ]
        finishTest.setTitleTextAttributes(attributes, for: .normal)
        
        // Se oculta el tab bar de este viewController
        self.tabBarController?.tabBar.isHidden = true
        
        // Se cargan los elementos de la UI con los layouts asignados
        // Etiqueta e imagen de la pregunta
        layoutLabelQuestion ()
        // Botones de las respuestas
        layoutButtonsAnswers (currentButton: firstAnswerButton, lastButton: nil)
        layoutButtonsAnswers (currentButton: secondAnswerButton, lastButton: firstAnswerButton)
        layoutButtonsAnswers (currentButton: thirdAnswerButton, lastButton: secondAnswerButton)
        layoutButtonsAnswers (currentButton: fourthAnswerButton, lastButton: thirdAnswerButton)
        // Imágenes de botones adelante y atrás de las preguntas
        buttonsBackAndNext ()
        // Etiqueta del cronómetro
        layoutChronometer ()
        // Botón de obtener una pista
        layoutClue ()
        
        self.navigationItem.setHidesBackButton(true, animated: true);

        self.navigationItem.title = "1/5"
        self.navigationController?.navigationBar.largeTitleTextAttributes = [NSAttributedString.Key.foregroundColor: UIColor.white]
        
        let iconImage : UIImage = UIImage(named: "boat3")!
        self.navigationItem.titleView = UIImageView(image: iconImage)
        self.navigationItem.titleView?.contentMode = .scaleAspectFit
        let titleView = UIView(frame: CGRect(x: 0, y: 0, width: 44, height: 44))
        self.navigationItem.titleView?.frame = titleView.bounds
        titleView.addSubview(self.navigationItem.titleView!)
        self.navigationItem.titleView = titleView
        
        // Probar con esto para el tema de la base de datos global
        // let appDelegate = UIApplication.shared.delegate as! AppDelegate
        // appDelegate.database
        
        // Comprobar que se obtienen correctamente los valores del segue
        
        
    }
    
    
    
    
  
    
    
    
    
    
    
    
    /* ================================================================== */
    /* ===== Función del layout de imagen y etiqueta de la pregunta ===== */
    /* ================================================================== */
    
    func layoutLabelQuestion () {
        
        // Se crean las variables de las medidas para los elementos UI
        let marginTop = screenHeight * 0.01
        let labelQuestionWidth = screenWidth * 0.95
        let labelQuestionHeight = screenHeight * 0.20
        
        // Se crea la ImageView del fondo de la pregunta
        let imageBackgroundName = "fondo_pregunta"
        let imageBackgroundQuestion = UIImage(named: imageBackgroundName)
        imageViewBackgroundQuestion = UIImageView(image: imageBackgroundQuestion!)
        
        // Se asigna el frame a la ImageView del fondo de la pregunta
        imageViewBackgroundQuestion.frame = CGRect(x: 0, y: marginTop+getNavBarHeight(), width: labelQuestionWidth, height: labelQuestionHeight)
        imageViewBackgroundQuestion.center.x = self.view.center.x
        
        // Se añade la ImageView del fondo de la pregunta a la vista
        view.addSubview(imageViewBackgroundQuestion)
        
        // Se asigna el frame y demás variables de diseño a la etiqueta de la
        // descripción de la pregunta
        labelQuestion.frame = CGRect(x: 0, y: 0, width: imageViewBackgroundQuestion.frame.width, height: imageViewBackgroundQuestion.frame.height)
        labelQuestion.center.x = self.view.center.x
        labelQuestion.text = "Descripción de la pregunta"
        labelQuestion.textAlignment = .center
        labelQuestion.textColor = .white
        labelQuestion.font = UIFont(name: "HelveticaNeue-medium", size: CGFloat(20))
        imageViewBackgroundQuestion.addSubview(labelQuestion)
        
    }
    
    /* ============================================================= */
    /* ===== Función del layout de etiquetas de las respuestas ===== */
    /* ============================================================= */
        
    func layoutButtonsAnswers (currentButton: UIButton, lastButton: UIButton?) {
        
        // Se crean las variables de las medidas para los elementos UI
        let marginTop = screenHeight * 0.01
        let buttonAnswerWidth = screenWidth * 0.95
        let buttonAnswerHeight = screenHeight * 0.085
        
        // Se asigna la altura y anchura para cada botón de las respuestas
        currentButton.frame.size = CGSize(width: buttonAnswerWidth, height: buttonAnswerHeight)
        
        // Se posiciona sobre la pantalla cada uno de los botones
        // Caso específico del primero botón
        if (currentButton == firstAnswerButton) {
            currentButton.frame.origin = CGPoint(x: 0.0, y: Double(imageViewBackgroundQuestion.frame.origin.y + imageViewBackgroundQuestion.frame.height + marginTop))
            currentButton.center.x = self.view.center.x
            currentButton.layer.shadowColor = UIColor(red: 0, green: 0, blue: 0, alpha: 0.125).cgColor
            currentButton.layer.shadowOffset = CGSize(width: 4.0, height: 4.0)
            currentButton.layer.shadowOpacity = 1.0
            currentButton.layer.shadowRadius = 0.0
            currentButton.layer.masksToBounds = false
            currentButton.layer.cornerRadius = 8.0
        }
        // Caso de los tres botones de respuesta restantes
        else {
            currentButton.frame.origin = CGPoint(x: 0.0, y: Double(lastButton!.frame.origin.y + buttonAnswerHeight + marginTop))
            currentButton.center.x = self.view.center.x
            currentButton.layer.shadowColor = UIColor(red: 0, green: 0, blue: 0, alpha: 0.125).cgColor
            currentButton.layer.shadowOffset = CGSize(width: 4.0, height: 4.0)
            currentButton.layer.shadowOpacity = 1.0
            currentButton.layer.shadowRadius = 0.0
            currentButton.layer.masksToBounds = false
            currentButton.layer.cornerRadius = 8.0
        }
        
    }
    
    /* =================================================================== */
    /* ===== Función del layout para backButton y nextButton de test ===== */
    /* =================================================================== */
    
    func buttonsBackAndNext () {
    
        // Variables para asignar la medida de ambos botones
        let widthButtons : CGFloat = screenWidth * 0.15
        let heightButtons : CGFloat = widthButtons / 1.60
        let sizeButtons : CGSize = CGSize (width: widthButtons, height: heightButtons)
        
        // Se asigna dicha medida a los botones
        lastQuestionButton.frame.size = sizeButtons
        nextQuestionButton.frame.size = sizeButtons
        
        // Layout para el botón "back" y "next"
        lastQuestionButton.frame.origin = CGPoint (x: screenWidth*0.025, y: fourthAnswerButton.frame.origin.y + fourthAnswerButton.frame.height + screenHeight * 0.025)
        nextQuestionButton.frame.origin = CGPoint (x: (screenWidth*0.975 - nextQuestionButton.frame.width), y: fourthAnswerButton.frame.origin.y + fourthAnswerButton.frame.height + screenHeight * 0.025)
        
    }
    
    func layoutChronometer () {
        
        chronometerLabel.frame.size = CGSize (width: screenWidth*0.50, height: lastQuestionButton.frame.size.height)
        chronometerLabel.frame.origin = CGPoint (x: 0.0, y: fourthAnswerButton.frame.origin.y + fourthAnswerButton.frame.height + screenHeight * 0.025)
        chronometerLabel.center.x = self.view.center.x
        
    }
    
    func layoutClue () {
        
        getClueButton.frame.size = CGSize (width: screenWidth*0.50, height: chronometerLabel.frame.size.height)
        getClueButton.frame.origin = CGPoint (x: 0.0, y: chronometerLabel.frame.origin.y + chronometerLabel.frame.height + screenHeight * 0.015)
        getClueButton.center.x = self.view.center.x
        
    }
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    func getNavBarHeight () -> CGFloat {
        let window = UIApplication.shared.windows.filter {$0.isKeyWindow}.first
        let statusBarHeight = window?.windowScene?.statusBarManager?.statusBarFrame.height ?? 0.0
        let navBarHeight = self.navigationController?.navigationBar.frame.height ?? 0.0
        let topBarHeight = statusBarHeight + navBarHeight
        return topBarHeight
    }
    

}


