//
//  TestViewController.swift
//  PER
//
//  Created by Conrado on 05/04/2020.
//  Copyright © 2020 Conrado. All rights reserved.
//

import UIKit
import PMAlertController
import APESuperHUD
import SQLite

class TestViewController: UIViewController {

    /* UI ELEMENTS */
    
    // Pregunta
    @IBOutlet weak var questionView: UIView!
    @IBOutlet weak var labelNumberQuestion: UILabel!
    @IBOutlet weak var labelTimeExam: UILabel!
    @IBOutlet weak var scrollViewTextQuestion: UIScrollView!
    @IBOutlet weak var labelTextQuestion: UILabel!
    
    // Respuesta 1
    @IBOutlet weak var answer1View: UIView!
    @IBOutlet weak var labelApartAnswer1: UILabel!
    @IBOutlet weak var labelTextAnswer1: UILabel!
    @IBOutlet weak var buttonAnswer1: UIButton!
    
    // Respuesta 2
    @IBOutlet weak var answer2View: UIView!
    @IBOutlet weak var labelApartAnswer2: UILabel!
    @IBOutlet weak var labelTextAnswer2: UILabel!
    @IBOutlet weak var buttonAnswer2: UIButton!
    
    // Respuesta 3
    @IBOutlet weak var answer3View: UIView!
    @IBOutlet weak var labelApartAnswer3: UILabel!
    @IBOutlet weak var labelTextAnswer3: UILabel!
    @IBOutlet weak var buttonAnswer3: UIButton!
    
    // Respuesta 4
    @IBOutlet weak var answer4View: UIView!
    @IBOutlet weak var labelApartAnswer4: UILabel!
    @IBOutlet weak var labelTextAnswer4: UILabel!
    @IBOutlet weak var buttonAnswer4: UIButton!
    
    // Pregunta anterior
    @IBOutlet weak var viewPreviousQuestion: UIView!
    @IBOutlet weak var imagePreviousQuestion: UIImageView!
    @IBOutlet weak var buttonPreviousQuestion: UIButton!
    
    // Pregunta siguiente
    @IBOutlet weak var viewNextQuestion: UIView!
    @IBOutlet weak var imageNextQuestion: UIImageView!
    @IBOutlet weak var buttonNextQuestion: UIButton!
    
    let menuBtn = UIButton(type: .custom)
    
    // Tamaño de pantalla
    var realHeightScreen : CGFloat!
    var realWidthScreen : CGFloat!
    var initialPoint : CGFloat!
    var endPoint : CGFloat!
    var statusBarHeight : CGFloat!
    var navBarHeight : CGFloat!
    
    // Datos de ejecución de examen
    var nameTest : String = ""
    var questionsToShow : [Question]!
    var questionNumber : Int = 0
    var questionsAnswered : [String] = []
    var correctAnswers : Int = 0
    var wrongAnswers : Int = 0
    var selectedAnswer : Int = 0
    var isCorrectAnswer : Bool = false
    let view1 : UIView = UIView ()
    var approved : Bool = false
    var typeExam : Int = 1
    let maxWrongChapter5 : Int = 2
    var wrongChapter5 : Int = 0
    let maxWrongChapter6 : Int = 5
    var wrongChapter6 : Int = 0
    let maxWrongChapter11 : Int = 2
    var wrongChapter11 : Int = 0
    let maxWrongTotal : Int  = 13
    
    override func viewDidLoad() {
        super.viewDidLoad()
                
        labelTimeExam.isHidden = true
        viewPreviousQuestion.isHidden = true
        
        self.navigationController?.navigationBar.isHidden = true
        view1.frame = CGRect (x: 0, y: 0, width: fullWidthScreen, height: fullHeightScreen)
        view1.backgroundColor = secondaryBlueColor
        self.view.addSubview(view1)
        
        print ("El examen escogido es :::: \(nameTest)")
        
        if (nameTest == "Simulación de examen real") {
            questionsToShow = getQuestionsForSimulation ()
            typeExam = 2
        } else {
            questionsToShow = get10QuestionsForTest (nameChapter: nameTest)
            typeExam = 1
        }
        
        // Show the first question
        labelTextQuestion.text = questionsToShow[questionNumber].question
        labelTextAnswer1.text = questionsToShow[questionNumber].answer1
        labelTextAnswer2.text = questionsToShow[questionNumber].answer2
        labelTextAnswer3.text = questionsToShow[questionNumber].answer3
        labelTextAnswer4.text = questionsToShow[questionNumber].answer4
        
        labelNumberQuestion.text = "Pregunta \(questionNumber+1)/\(questionsToShow.count)"
        
        // viewPreviousQuestion.isHidden = true
        buttonNextQuestion.isEnabled = false
        imageNextQuestion.alpha = 0.4
        
        navigationItem.title = nameTest
        
        // Se esconde el tab bar de este viewController
        self.tabBarController?.tabBar.isHidden = true
        
        // Se esconde el botón atrás de navegación
        self.navigationItem.setHidesBackButton(true, animated: true)
        
        // Se asigna el diseño de la barra de navegación
        setDesignNavBar(navigationItem: navigationItem, appearance: UINavigationBarAppearance())
        
        // Botón de la barra de navegación
        menuBtn.frame = CGRect(x: 0.0, y: 0.0, width: 0.0, height: 0.0)
        menuBtn.setImage(UIImage(named:"finish_test"), for: .normal)
        menuBtn.addTarget(self, action: #selector(finishTest), for: UIControl.Event.touchUpInside)
        let menuBarItem = UIBarButtonItem(customView: menuBtn)
        let currWidth = menuBarItem.customView?.widthAnchor.constraint(equalToConstant: 18.0)
        currWidth?.isActive = true
        let currHeight = menuBarItem.customView?.heightAnchor.constraint(equalToConstant: 18.0)
        currHeight?.isActive = true
        self.navigationItem.rightBarButtonItem = menuBarItem
    
        // Inicialización de las variables de tamaño
        InitialAndEndPoint ()
    
        /* Mostrar la pregunta en pantalla */
        PositionQuestion ()
        
        /* Mostrar las respuestas en pantalla */
        PositionElementsOf4Answers (lastElement: questionView, viewAnswer: answer1View, labelAppart: labelApartAnswer1, labelText: labelTextAnswer1, buttonAnswer: buttonAnswer1)
        PositionElementsOf4Answers(lastElement: answer1View, viewAnswer: answer2View, labelAppart: labelApartAnswer2, labelText: labelTextAnswer2, buttonAnswer: buttonAnswer2)
        PositionElementsOf4Answers(lastElement: answer2View, viewAnswer: answer3View, labelAppart: labelApartAnswer3, labelText: labelTextAnswer3, buttonAnswer: buttonAnswer3)
        PositionElementsOf4Answers(lastElement: answer3View, viewAnswer: answer4View, labelAppart: labelApartAnswer4, labelText: labelTextAnswer4, buttonAnswer: buttonAnswer4)
        
        /* Mostrar los botones de anterior y siguiente pregunta */
        PositionPreviousAndNextQuestion ()
    }
    
    
    override func viewWillAppear(_ animated: Bool) {
        // - - - - -
        HUDAppearance.backgroundColor = secondaryBlueColor.withAlphaComponent(1)
        HUDAppearance.titleFont = UIFont.systemFont(ofSize: 15, weight: .bold)
        HUDAppearance.messageFont = UIFont.systemFont(ofSize: 15, weight: .regular)
        // HUDAppearance.animateInTime = 2
        HUDAppearance.hudSize = CGSize(width: 170, height: 135)
        // HUDAppearance.shadow = true
        HUDAppearance.cancelableOnTouch = false

        
        let hudViewController = APESuperHUD(style: .loadingIndicator(type: .standard), title: "El examen se está configurando", message: "Serán solo unos segundos...")
        present(hudViewController, animated: true)

        DispatchQueue.main.asyncAfter(deadline: .now() + 2, execute: {
            hudViewController.dismiss(animated: true)
            DispatchQueue.main.asyncAfter(deadline: .now() + 0.75) {
                self.navigationController?.navigationBar.isHidden = false
                self.view1.isHidden = true
            }
        })
    }
    
    
    
    
    
    @IBAction func buttonAnswer1(_ sender: UIButton) {
        selectedAnswer = 1
        if (questionsToShow[questionNumber].correctAnswer == 1) {
            labelTextAnswer1.backgroundColor = correctAnswerColorGreen
            labelTextAnswer1.textColor = UIColor.white
            isCorrectAnswer = true
            correctAnswers = correctAnswers + 1
        } else if (questionsToShow[questionNumber].correctAnswer == 2) {
            labelTextAnswer1.backgroundColor = wrongAnswerColorRed
            labelTextAnswer1.textColor = UIColor.white
            labelTextAnswer2.backgroundColor = correctAnswerColorGreen
            labelTextAnswer2.textColor = UIColor.white
            isCorrectAnswer = false
            if typeExam == 2 { addWrongAnswerToChapter () }
            wrongAnswers = wrongAnswers + 1
        } else if (questionsToShow[questionNumber].correctAnswer == 3) {
            labelTextAnswer1.backgroundColor = wrongAnswerColorRed
            labelTextAnswer1.textColor = UIColor.white
            labelTextAnswer3.backgroundColor = correctAnswerColorGreen
            labelTextAnswer3.textColor = UIColor.white
            isCorrectAnswer = false
            if typeExam == 2 { addWrongAnswerToChapter () }
            wrongAnswers = wrongAnswers + 1
        } else {
            labelTextAnswer1.backgroundColor = wrongAnswerColorRed
            labelTextAnswer1.textColor = UIColor.white
            labelTextAnswer4.backgroundColor = correctAnswerColorGreen
            labelTextAnswer4.textColor = UIColor.white
            isCorrectAnswer = false
            if typeExam == 2 { addWrongAnswerToChapter () }
            wrongAnswers = wrongAnswers + 1
        }
        
        if (questionNumber < questionsToShow.count-1) {
            buttonNextQuestion.isEnabled = true
            imageNextQuestion.alpha = 1
        } else {
            buttonNextQuestion.isEnabled = false
            view1.isHidden = false
            endTest ()
        }
        disableButtonsAnswers ()
    }
    
    @IBAction func buttonAnswer2(_ sender: UIButton) {
        selectedAnswer = 2
        if (questionsToShow[questionNumber].correctAnswer == 1) {
            labelTextAnswer2.backgroundColor = wrongAnswerColorRed
            labelTextAnswer2.textColor = UIColor.white
            labelTextAnswer1.backgroundColor = correctAnswerColorGreen
            labelTextAnswer1.textColor = UIColor.white
            isCorrectAnswer = false
            if typeExam == 2 { addWrongAnswerToChapter () }
            wrongAnswers = wrongAnswers + 1
        } else if (questionsToShow[questionNumber].correctAnswer == 2) {
            labelTextAnswer2.backgroundColor = correctAnswerColorGreen
            labelTextAnswer2.textColor = UIColor.white
            isCorrectAnswer = true
            correctAnswers = correctAnswers + 1
        } else if (questionsToShow[questionNumber].correctAnswer == 3) {
            labelTextAnswer2.backgroundColor = wrongAnswerColorRed
            labelTextAnswer2.textColor = UIColor.white
            labelTextAnswer3.backgroundColor = correctAnswerColorGreen
            labelTextAnswer3.textColor = UIColor.white
            isCorrectAnswer = false
            if typeExam == 2 { addWrongAnswerToChapter () }
            wrongAnswers = wrongAnswers + 1
        } else {
            labelTextAnswer2.backgroundColor = wrongAnswerColorRed
            labelTextAnswer2.textColor = UIColor.white
            labelTextAnswer4.backgroundColor = correctAnswerColorGreen
            labelTextAnswer4.textColor = UIColor.white
            isCorrectAnswer = false
            if typeExam == 2 { addWrongAnswerToChapter () }
            wrongAnswers = wrongAnswers + 1
        }
        
        if (questionNumber < questionsToShow.count-1) {
            buttonNextQuestion.isEnabled = true
            imageNextQuestion.alpha = 1
        }
        else {
            buttonNextQuestion.isEnabled = false
            view1.isHidden = false
            endTest ()
        }
        disableButtonsAnswers ()
    }

    @IBAction func buttonAnswer3(_ sender: UIButton) {
        selectedAnswer = 3
        if (questionsToShow[questionNumber].correctAnswer == 1) {
            labelTextAnswer3.backgroundColor = wrongAnswerColorRed
            labelTextAnswer3.textColor = UIColor.white
            labelTextAnswer1.backgroundColor = correctAnswerColorGreen
            labelTextAnswer1.textColor = UIColor.white
            isCorrectAnswer = false
            if typeExam == 2 { addWrongAnswerToChapter () }
            wrongAnswers = wrongAnswers + 1
        } else if (questionsToShow[questionNumber].correctAnswer == 2) {
            labelTextAnswer3.backgroundColor = wrongAnswerColorRed
            labelTextAnswer3.textColor = UIColor.white
            labelTextAnswer2.backgroundColor = correctAnswerColorGreen
            labelTextAnswer2.textColor = UIColor.white
            isCorrectAnswer = false
            if typeExam == 2 { addWrongAnswerToChapter () }
            wrongAnswers = wrongAnswers + 1
        } else if (questionsToShow[questionNumber].correctAnswer == 3) {
            labelTextAnswer3.backgroundColor = correctAnswerColorGreen
            labelTextAnswer3.textColor = UIColor.white
            isCorrectAnswer = true
            correctAnswers = correctAnswers + 1
        } else {
            labelTextAnswer3.backgroundColor = wrongAnswerColorRed
            labelTextAnswer3.textColor = UIColor.white
            labelTextAnswer4.backgroundColor = correctAnswerColorGreen
            labelTextAnswer4.textColor = UIColor.white
            isCorrectAnswer = false
            if typeExam == 2 { addWrongAnswerToChapter () }
            wrongAnswers = wrongAnswers + 1
        }
        
        if (questionNumber < questionsToShow.count-1) {
            buttonNextQuestion.isEnabled = true
            imageNextQuestion.alpha = 1
        }
        else {
            buttonNextQuestion.isEnabled = false
            view1.isHidden = false
            endTest ()
        }
        disableButtonsAnswers ()
    }
    
    @IBAction func buttonAnswer4(_ sender: UIButton) {
        selectedAnswer = 4
        if (questionsToShow[questionNumber].correctAnswer == 1) {
            labelTextAnswer4.backgroundColor = wrongAnswerColorRed
            labelTextAnswer4.textColor = UIColor.white
            labelTextAnswer1.backgroundColor = correctAnswerColorGreen
            labelTextAnswer1.textColor = UIColor.white
            isCorrectAnswer = false
            if typeExam == 2 { addWrongAnswerToChapter () }
            wrongAnswers = wrongAnswers + 1
        } else if (questionsToShow[questionNumber].correctAnswer == 2) {
            labelTextAnswer4.backgroundColor = wrongAnswerColorRed
            labelTextAnswer2.backgroundColor = correctAnswerColorGreen
            isCorrectAnswer = false
            if typeExam == 2 { addWrongAnswerToChapter () }
            wrongAnswers = wrongAnswers + 1
        } else if (questionsToShow[questionNumber].correctAnswer == 3) {
            labelTextAnswer4.backgroundColor = wrongAnswerColorRed
            labelTextAnswer4.textColor = UIColor.white
            labelTextAnswer3.backgroundColor = correctAnswerColorGreen
            labelTextAnswer3.textColor = UIColor.white
            isCorrectAnswer = false
            if typeExam == 2 { addWrongAnswerToChapter () }
            wrongAnswers = wrongAnswers + 1
        } else {
            labelTextAnswer4.backgroundColor = correctAnswerColorGreen
            labelTextAnswer4.textColor = UIColor.white
            isCorrectAnswer = true
            correctAnswers = correctAnswers + 1
        }
        
        if (questionNumber < questionsToShow.count-1) {
            buttonNextQuestion.isEnabled = true
            imageNextQuestion.alpha = 1
        }
        else {
            buttonNextQuestion.isEnabled = false
            view1.isHidden = false
            endTest ()
        }
        disableButtonsAnswers ()
    }
    
    // - - - -
    func disableButtonsAnswers () {
        buttonAnswer1.isEnabled = false
        buttonAnswer2.isEnabled = false
        buttonAnswer3.isEnabled = false
        buttonAnswer4.isEnabled = false
    }
    // - - - -
    func enableButtonsAnswers () {
        buttonAnswer1.isEnabled = true
        buttonAnswer2.isEnabled = true
        buttonAnswer3.isEnabled = true
        buttonAnswer4.isEnabled = true
    }
    
    func addWrongAnswerToChapter () {
        if questionsToShow[questionNumber].chapter == chaptersName[4] {
            print (" .... \(chaptersName[4])")
            wrongChapter5 = wrongChapter5 + 1
            print (" .... El número de respuestas incorrectas para el tema 5 es de: \(wrongChapter5)")
        }
        else if questionsToShow[questionNumber].chapter == chaptersName[5] {
            print (" .... \(chaptersName[5])")
            wrongChapter6 = wrongChapter6 + 1
            print (" .... El número de respuestas incorrectas para el tema 6 es de: \(wrongChapter6)")
        }
        else if questionsToShow[questionNumber].chapter == chaptersName[10] {
            print (" .... \(chaptersName[10])")
            wrongChapter11 = wrongChapter11 + 1
            print (" .... El número de respuestas incorrectas para el tema 11 es de: \(wrongChapter11)")
        }
        else { }
    }
    
    func endTest () {
        
        var title : String = ""
        var description : String = ""
        var stringImage : String = ""
        
        self.navigationController?.navigationBar.isHidden = true
        menuBtn.isHidden = true
        
        if typeExam == 1 {
            if (correctAnswers >= wrongAnswers) {
                title = "¡¡ ENHORABUENA !!"
                description = "Has aprobado el examen de \(nameTest) con una nota de \(correctAnswers)/\(questionsToShow.count). ¡Sigue así!"
                stringImage = "correct_answer_optimizada"
                approved = true
            } else {
                title = "Vaya..."
                description = "No has aprobado el examen de \(nameTest)." + "\n" + "Has obtenido un \(correctAnswers)/\(questionsToShow.count)." + "\n" + "Toca continuar aprendido, ¡ánimo!"
                stringImage = "wrong_answer_optimizada"
                approved = false
            }
        } else if typeExam == 2 {
            if wrongAnswers > maxWrongTotal {
                title = "Vaya..."
                description = "No has aprobado la \(nameTest.lowercased())." + "\n" + "- Has fallado \(wrongAnswers) preguntas, más del total permitidas (\(maxWrongTotal)).\n"// + "\n" + "Toca continuar aprendido, ¡ánimo!"
                stringImage = "wrong_answer_optimizada"
                approved = false
            }
            if wrongChapter5 > maxWrongChapter5 {
                title = "Vaya..."
                description = description + "- Has fallado \(wrongChapter5) preguntas del tema \(questionsToShow[questionNumber].chapter), más del total permitidas (\(maxWrongChapter5)).\n"
                stringImage = "wrong_answer_optimizada"
                approved = false
            }
            if wrongChapter6 > maxWrongChapter6 {
                title = "Vaya..."
                description = description + "- Has fallado \(wrongChapter6) preguntas del tema \(questionsToShow[questionNumber].chapter), más del total permitidas (\(maxWrongChapter6)).\n"
                stringImage = "wrong_answer_optimizada"
                approved = false
            }
            if wrongChapter11 > maxWrongChapter11 {
                title = "Vaya..."
                description = description + "- Has fallado \(wrongChapter11) preguntas del tema \(questionsToShow[questionNumber].chapter), más del total permitidas (\(maxWrongChapter11))."
                stringImage = "wrong_answer_optimizada"
                approved = false
            }
            
            // Caso de aprobado
            if (wrongAnswers <= maxWrongTotal && wrongChapter5 <= maxWrongChapter5 && wrongChapter6 <= maxWrongChapter6 && wrongChapter11 <= maxWrongChapter11) {
                title = "¡¡ ENHORABUENA !!"
                description = "Has aprobado el examen de \(nameTest) con una nota de \(correctAnswers)/\(questionsToShow.count). ¡Sigue así!"
                stringImage = "correct_answer_optimizada"
                approved = true
            }
            
        }
        
        /* - - - - - - - - - - - - - - - - */
        /* Se inserta el examen en la BBDD */
        /* - - - - - - - - - - - - - - - - */
        do {
            let idExam : Int = try databaseG.scalar(historyTable.count)
            let insert = historyTable.insert(id_exam <- (idExam + 1), chapter_exam <- nameTest, number_questions <- (correctAnswers + wrongAnswers), correctQuestions <- correctAnswers, wrongQuestions <- wrongAnswers, isApproved <- approved)
            try databaseG.run(insert)
        } catch {
            print (error)
        }
        
        let alertVC = PMAlertController(title: title, description: description, image: UIImage(named: stringImage), style: .alert)
        alertVC.addAction(PMAlertAction(title: "Volver al inicio :)", style: .default, action: { () -> Void in
            self.performSegue(withIdentifier: "returnTestToInit", sender: nil)
            self.navigationController?.navigationBar.isHidden = true
            self.title = ""
        }))
        self.present(alertVC, animated: true, completion: nil)
        
        
    }
    
    
    
    
    @IBAction func previousQuestion(_ sender: UIButton) {
        
        
        
    }
    
    @IBAction func nextQuestion(_ sender: UIButton) {
        
        /*
        let questionAnswered = QuestionAnswered (
            id: questionsToShow[questionNumber].id,
            chapter: questionsToShow[questionNumber].chapter,
            question: questionsToShow[questionNumber].question,
            answer1: questionsToShow[questionNumber].answer1,
            answer2: questionsToShow[questionNumber].answer2,
            answer3: questionsToShow[questionNumber].answer3,
            answer4: questionsToShow[questionNumber].answer4,
            correctAnswer: questionsToShow[questionNumber].correctAnswer,
            selectedAnswer: selectedAnswer,
            isCorrect: isCorrectAnswer)
        */
        
        questionNumber = questionNumber + 1
        labelNumberQuestion.text = "Pregunta \(questionNumber+1)/\(questionsToShow.count)"
    
        labelTextQuestion.text = questionsToShow[questionNumber].question
        labelTextAnswer1.text = questionsToShow[questionNumber].answer1
        labelTextAnswer2.text = questionsToShow[questionNumber].answer2
        labelTextAnswer3.text = questionsToShow[questionNumber].answer3
        labelTextAnswer4.text = questionsToShow[questionNumber].answer4
        
        // Label 1
        labelTextAnswer1.backgroundColor = .white
        labelTextAnswer1.textColor = secondaryBlueColor
        // Label 2
        labelTextAnswer2.backgroundColor = .white
        labelTextAnswer2.textColor = secondaryBlueColor
        // Label 3
        labelTextAnswer3.backgroundColor = .white
        labelTextAnswer3.textColor = secondaryBlueColor
        // Label 4
        labelTextAnswer4.backgroundColor = .white
        labelTextAnswer4.textColor = secondaryBlueColor
        
        enableButtonsAnswers ()
        imageNextQuestion.alpha = 0.4
        buttonNextQuestion.isEnabled = false
        
        
    }
    

    
    @objc func finishTest () {
        let alert = UIAlertController(title: "¿Estás seguro que deseas salir del examen?",
                                      message: "Si sales del examen sin finalizarlo contará como un examen suspenso en tus estadísticas",
                                      preferredStyle: .alert)
        let actionContinue = UIAlertAction(title: "Continuar", style: .default, handler: nil)
        let actionExit = UIAlertAction(title: "Salir", style: .destructive, handler: { action in
            // Almacenamiento del examen suspenso en la base de datos
            do {
                let idExam : Int = try databaseG.scalar(historyTable.count)
                let insert = historyTable.insert(id_exam <- (idExam + 1), chapter_exam <- self.nameTest, number_questions <- (self.correctAnswers + self.wrongAnswers), correctQuestions <- self.correctAnswers, wrongQuestions <- self.wrongAnswers, isApproved <- false)
                try databaseG.run(insert)
            } catch {
                print (error)
            }
            // Volver a la pantalla de inicio
            self.performSegue(withIdentifier: "returnTestToInit", sender: nil)
        })
        alert.addAction(actionContinue)
        alert.addAction(actionExit)
        present(alert, animated: true, completion: nil)
    }
    
 
    
    func PositionQuestion () {
        
        // Variables
        let marginLat = realWidthScreen * 0.02
        let heightQuestionView = realHeightScreen * 0.285
        
        // Eliminación de las constraints de autolayout
        labelNumberQuestion.translatesAutoresizingMaskIntoConstraints = false
        labelTimeExam.translatesAutoresizingMaskIntoConstraints = false
        scrollViewTextQuestion.translatesAutoresizingMaskIntoConstraints = false
        labelTextQuestion.translatesAutoresizingMaskIntoConstraints = false
        
        // Vista de la pregunta
        questionView.frame = CGRect (x: 0, y: initialPoint, width: realWidthScreen, height: heightQuestionView)
        
        // Constraints del número de la pregunta
        labelNumberQuestion.topAnchor.constraint(equalTo: questionView.topAnchor, constant: -2).isActive = true
        labelNumberQuestion.leadingAnchor.constraint(equalTo: questionView.leadingAnchor, constant: realWidthScreen * 0.03).isActive = true
        labelNumberQuestion.heightAnchor.constraint(equalToConstant: heightQuestionView * 0.19).isActive = true
        labelNumberQuestion.widthAnchor.constraint(equalToConstant: realWidthScreen * 0.48).isActive = true
        
        // Constraints del contador de tiempo
        labelTimeExam.topAnchor.constraint(equalTo: questionView.topAnchor).isActive = true
        labelTimeExam.rightAnchor.constraint(equalTo: questionView.rightAnchor, constant: -(realWidthScreen * 0.03)).isActive = true
        labelTimeExam.heightAnchor.constraint(equalToConstant: heightQuestionView * 0.20).isActive = true
        labelTimeExam.widthAnchor.constraint(equalToConstant: realWidthScreen * 0.48).isActive = true
        
        // Constraints del scroll de la pregunta
        scrollViewTextQuestion.centerXAnchor.constraint(equalTo: questionView.centerXAnchor).isActive = true
        scrollViewTextQuestion.widthAnchor.constraint(equalTo: questionView.widthAnchor, constant: -(marginLat * 3)).isActive = true
        scrollViewTextQuestion.topAnchor.constraint(equalTo: questionView.topAnchor, constant: heightQuestionView * 0.19).isActive = true
        scrollViewTextQuestion.bottomAnchor.constraint(equalTo: questionView.bottomAnchor, constant: -(heightQuestionView * 0.05)).isActive = true
        
        // Constraints del texto de la pregunta
        labelTextQuestion.centerXAnchor.constraint(equalTo: scrollViewTextQuestion.centerXAnchor).isActive = true
        labelTextQuestion.centerYAnchor.constraint(equalTo: scrollViewTextQuestion.centerYAnchor).isActive = true
        labelTextQuestion.widthAnchor.constraint(equalTo: scrollViewTextQuestion.widthAnchor).isActive = true
        labelTextQuestion.topAnchor.constraint(equalTo: scrollViewTextQuestion.topAnchor).isActive = true
        labelTextQuestion.bottomAnchor.constraint(equalTo: scrollViewTextQuestion.bottomAnchor).isActive = true
        
        // Diseño de los elementos
        scrollViewTextQuestion.indicatorStyle = .white
        scrollViewTextQuestion.layer.masksToBounds = true
        scrollViewTextQuestion.layer.cornerRadius = 10
        labelTextQuestion.layer.masksToBounds = true
        labelTextQuestion.layer.cornerRadius = 10
        
    }
    
    


    func PositionElementsOf4Answers (lastElement : AnyObject, viewAnswer : UIView, labelAppart : UILabel, labelText : UILabel, buttonAnswer : UIButton) {
        
        // Variables
        let widthAnswerView = realWidthScreen * 0.96
        let heightAnswerView = realHeightScreen * 0.1425
        let marginLat = (realWidthScreen - widthAnswerView) / 2
        let nextAnswerPosition = lastElement.frame.origin.y + lastElement.frame.height + (realHeightScreen * 0.0075)
        
        // Eliminación de las constraints de autolayout
        labelAppart.translatesAutoresizingMaskIntoConstraints = false
        labelText.translatesAutoresizingMaskIntoConstraints = false
        buttonAnswer.translatesAutoresizingMaskIntoConstraints = false
        
        // Posicionamiento de la vista de la respuesta
        viewAnswer.frame = CGRect (x: marginLat, y: nextAnswerPosition, width: widthAnswerView, height: heightAnswerView)
        
        // Constraints del apartado
        labelAppart.topAnchor.constraint(equalTo: viewAnswer.topAnchor).isActive = true
        labelAppart.bottomAnchor.constraint(equalTo: viewAnswer.bottomAnchor).isActive = true
        labelAppart.leadingAnchor.constraint(equalTo: viewAnswer.leadingAnchor).isActive = true
        labelAppart.widthAnchor.constraint(equalToConstant: widthAnswerView * 0.11).isActive = true
        
        // Constraints de la respuesta
        labelText.topAnchor.constraint(equalTo: viewAnswer.topAnchor, constant: widthAnswerView * 0.01).isActive = true
        labelText.bottomAnchor.constraint(equalTo: viewAnswer.bottomAnchor, constant: -widthAnswerView * 0.01).isActive = true
        labelText.rightAnchor.constraint(equalTo: viewAnswer.rightAnchor, constant: -widthAnswerView * 0.01).isActive = true
        labelText.widthAnchor.constraint(equalToConstant: widthAnswerView * 0.88).isActive = true
        
        // Constraints del botón
        buttonAnswer.topAnchor.constraint(equalTo: viewAnswer.topAnchor).isActive = true
        buttonAnswer.bottomAnchor.constraint(equalTo: viewAnswer.bottomAnchor).isActive = true
        buttonAnswer.leadingAnchor.constraint(equalTo: viewAnswer.leadingAnchor).isActive = true
        buttonAnswer.rightAnchor.constraint(equalTo: viewAnswer.rightAnchor).isActive = true
        
        // Diseño de los elementos
        viewAnswer.layer.masksToBounds = true
        viewAnswer.layer.cornerRadius = 10
        viewAnswer.layer.borderColor = mainBlue.cgColor
        labelText.layer.masksToBounds = true
        labelText.layer.cornerRadius = 7.5
    }
    
    
    
    
    func PositionPreviousAndNextQuestion () {
        
        // Variables
        let heightMainView = realHeightScreen * 0.09
        let widthMainView = heightMainView
        let marginLat = realWidthScreen * 0.035
        
        // Eliminación de las constraints de autolayout
        buttonPreviousQuestion.translatesAutoresizingMaskIntoConstraints = false
        buttonNextQuestion.translatesAutoresizingMaskIntoConstraints = false
        imagePreviousQuestion.translatesAutoresizingMaskIntoConstraints = false
        imageNextQuestion.translatesAutoresizingMaskIntoConstraints = false
        
        // ----------
        viewPreviousQuestion.frame = CGRect (
            x: marginLat,
            y: answer4View.frame.origin.y + answer4View.frame.height + realHeightScreen * 0.007,
            width: widthMainView,
            height: heightMainView
        )
        // viewPreviousQuestion.backgroundColor = .red
        
        // ----------
        viewNextQuestion.frame = CGRect (
            x: realWidthScreen - marginLat - widthMainView,
            y: answer4View.frame.origin.y + answer4View.frame.height + realHeightScreen * 0.007,
            width: widthMainView,
            height: heightMainView
        )
        // viewNextQuestion.backgroundColor = .red
        
        // Imagen de pregunta anterior
        imagePreviousQuestion.heightAnchor.constraint(equalToConstant: heightMainView).isActive = true
        imagePreviousQuestion.widthAnchor.constraint(equalToConstant: heightMainView).isActive = true
        imagePreviousQuestion.leftAnchor.constraint(equalTo: viewPreviousQuestion.leftAnchor).isActive = true
        imagePreviousQuestion.centerYAnchor.constraint(equalTo: viewPreviousQuestion.centerYAnchor).isActive = true
        imagePreviousQuestion.contentMode = .scaleAspectFit
        
        // Imagen de pregunta siguiente
        imageNextQuestion.heightAnchor.constraint(equalToConstant: heightMainView).isActive = true
        imageNextQuestion.widthAnchor.constraint(equalToConstant: heightMainView).isActive = true
        imageNextQuestion.rightAnchor.constraint(equalTo: viewNextQuestion.rightAnchor).isActive = true
        imageNextQuestion.centerYAnchor.constraint(equalTo: viewNextQuestion.centerYAnchor).isActive = true
        imageNextQuestion.contentMode = .scaleAspectFit
        
        // Botón previous
        buttonPreviousQuestion.topAnchor.constraint(equalTo: viewPreviousQuestion.topAnchor).isActive = true
        buttonPreviousQuestion.bottomAnchor.constraint(equalTo: viewPreviousQuestion.bottomAnchor).isActive = true
        buttonPreviousQuestion.leadingAnchor.constraint(equalTo: viewPreviousQuestion.leadingAnchor).isActive = true
        buttonPreviousQuestion.rightAnchor.constraint(equalTo: viewPreviousQuestion.rightAnchor).isActive = true
        
        // Botón next
        buttonNextQuestion.topAnchor.constraint(equalTo: viewNextQuestion.topAnchor).isActive = true
        buttonNextQuestion.bottomAnchor.constraint(equalTo: viewNextQuestion.bottomAnchor).isActive = true
        buttonNextQuestion.leadingAnchor.constraint(equalTo: viewNextQuestion.leadingAnchor).isActive = true
        buttonNextQuestion.rightAnchor.constraint(equalTo: viewNextQuestion.rightAnchor).isActive = true
        
    }
    
    
    
    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        // Get the new view controller using segue.destination.
        // Pass the selected object to the new view controller.
    }
    */
    
    func InitialAndEndPoint () {
        // height of common elements: statusBar, navBar
        statusBarHeight = getStatusBarHeight()
        navBarHeight = getNavBarHeight(navigationController: self.navigationController!)
        // real height and real width of screen
        realHeightScreen = fullHeightScreen - statusBarHeight - navBarHeight
        realWidthScreen = fullWidthScreen
        // initial point and end point of screen
        initialPoint = getTopBarHeight(statusBarHeight: statusBarHeight, navBarHeight: navBarHeight)
        endPoint = fullHeightScreen
    }
    
}


@IBDesignable public class PaddingLabel : UILabel {
    
    @IBInspectable var topInset : CGFloat = 0
    @IBInspectable var bottomInset : CGFloat = 0
    @IBInspectable var leftInset : CGFloat = 0
    @IBInspectable var rightInset : CGFloat = 0
    
    public override func drawText(in rect: CGRect) {
        let insets = UIEdgeInsets.init(top: topInset, left: leftInset, bottom: bottomInset, right: rightInset)
        super.drawText(in: rect.inset(by: insets))
    }
    
    public override var intrinsicContentSize: CGSize {
        let size = super.intrinsicContentSize
        return CGSize(width: size.width + leftInset + rightInset, height: size.height + topInset + bottomInset)
    }
    
}




