//
//  SideMenuCell.swift
//  PER
//
//  Created by Conrado on 17/04/2020.
//  Copyright © 2020 Conrado. All rights reserved.
//

import UIKit

class SideMenuCell: UITableViewCell {

    
    @IBOutlet weak var iconView: UIImageView!
    @IBOutlet weak var nameApart: UILabel!
    
    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)
        if selected {
            contentView.backgroundColor = UIColor.white
            iconView.tintColor = secondaryBlueColor
            nameApart.textColor = secondaryBlueColor
        } else {
            contentView.backgroundColor = secondaryBlueColor
            iconView.tintColor = UIColor.white
            nameApart.textColor = UIColor.white
        }
    }
    
    
    func setConstraints () {
        
        let sizeIcon : CGFloat = 28.0
        let marginLeftIcon : CGFloat = 15.0
        let marginLeftTitle : CGFloat = 15.0
        
        iconView.translatesAutoresizingMaskIntoConstraints = false
        nameApart.translatesAutoresizingMaskIntoConstraints = false
        
        iconView.leftAnchor.constraint(equalTo: self.leftAnchor, constant: marginLeftIcon).isActive = true
        iconView.heightAnchor.constraint(equalToConstant: sizeIcon).isActive = true
        iconView.widthAnchor.constraint(equalToConstant: sizeIcon).isActive = true
        iconView.centerYAnchor.constraint(equalTo: self.centerYAnchor).isActive = true
        
        nameApart.leftAnchor.constraint(equalTo: iconView.rightAnchor, constant: marginLeftTitle).isActive = true
        nameApart.rightAnchor.constraint(equalTo: self.rightAnchor, constant: -5).isActive = true
        nameApart.topAnchor.constraint(equalTo: self.topAnchor).isActive = true
        nameApart.bottomAnchor.constraint(equalTo: self.bottomAnchor).isActive = true
        
    }
    
    

}
