//
//  DetailOfficialContent.swift
//  PER
//
//  Created by Conrado on 13/05/2020.
//  Copyright © 2020 Conrado. All rights reserved.
//

import UIKit

class DetailOfficialContent: UIViewController, UITableViewDelegate, UITableViewDataSource {
    
    @IBOutlet weak var tableView: UITableView!
    @IBOutlet weak var labelChapter: UILabel!
    
    
    //
    var indexChapter : Int!
    var dataTitle : [String] = []
    var dataDescription : [[String]] = []
    //
    let upArrow : String = "arrowtriangle.up.fill"
    let downArrow : String = "arrowtriangle.down.fill"
    var imageHeader : UIImage = UIImage(systemName: "arrowtriangle.down.fill")!
    var images : [String] = []
    //
    var arrayVacio : [[String]] = []
    var state : String = ""
    var twoLines : Bool = false
    var buttonHeader : UIButton!
    
    
    // MARK: - Funciones de carga de la vista
    // ......................................
    
    override func viewDidLoad() {
        super.viewDidLoad()
        tableView.separatorStyle = .singleLine
        tableView.separatorColor = UIColor.white.withAlphaComponent(0.25)
        labelChapter.layer.addBorder(edge: .bottom, color: UIColor.white, thickness: 0.25)
    }
    
    override func viewWillAppear(_ animated: Bool) {
        // Se asignan los contenidos a mostrar (títulos y descripciones) en función
        // del tema que ha escogido el usuario en el scroll horizontal
        if indexChapter == 0 {
            dataTitle = titleSubChapterT1
            dataDescription = descriptionSubChapterT1
        } else if indexChapter == 1 {
            dataTitle = titleSubChapterT2
            dataDescription = descriptionSubChapterT2
        } else if indexChapter == 2 {
        dataTitle = titleSubChapterT3
            dataDescription = descriptionSubChapterT3
        } else if indexChapter == 3 {
            dataTitle = titleSubChapterT4
            dataDescription = descriptionSubChapterT4
        } else if indexChapter == 4 {
            dataTitle = titleSubChapterT5
            dataDescription = descriptionSubChapterT5
        } else if indexChapter == 5 {
            dataTitle = titleSubChapterT6
            dataDescription = descriptionSubChapterT6
        } else if indexChapter == 6 {
            dataTitle = titleSubChapterT7
            dataDescription = descriptionSubChapterT7
        } else if indexChapter == 7 {
            dataTitle = titleSubChapterT8
            dataDescription = descriptionSubChapterT8
        } else if indexChapter == 8 {
            dataTitle = titleSubChapterT9
            dataDescription = descriptionSubChapterT9
        } else if indexChapter == 9 {
            dataTitle = titleSubChapterT10
            dataDescription = descriptionSubChapterT10
        } else if indexChapter == 10 {
            dataTitle = titleSubChapterT11
            dataDescription = descriptionSubChapterT11
        }
        
        labelChapter.text = chaptersName[indexChapter]
        
        // Se inicializan los arrays de imágenes e información
        if images.isEmpty && arrayVacio.isEmpty {
            for i in 0...dataTitle.count-1 {
                images.insert(downArrow, at: i)
                arrayVacio.append([])
            }
        }
    }
    
    
    // MARK: - Métodos de tableView
    // ............................
    
    func tableView(_ tableView: UITableView, viewForHeaderInSection section: Int) -> UIView? {
        
        // Vista de la sección
        let viewHeader : UIView = UIView ()
        
        // Creación del botón de la sección
        buttonHeader = UIButton (type: .system)
        buttonHeader.tag = section
        buttonHeader.titleLabel?.font = UIFont(name: "IBMPlexSans-SemiBold", size: 15)
        buttonHeader.titleLabel?.lineBreakMode = NSLineBreakMode.byWordWrapping
        buttonHeader.setTitle(dataTitle[section], for: .normal)
        buttonHeader.contentHorizontalAlignment = .left
        buttonHeader.titleEdgeInsets = UIEdgeInsets(top: 0, left: -4, bottom: 0, right: 0)
        buttonHeader.setTitleColor(.white, for: .normal)
        buttonHeader.backgroundColor = secondaryBlueColor
        buttonHeader.setImage(UIImage(systemName: images[section])!, for: .normal)
        buttonHeader.addTarget(self, action: #selector(handleDropDown), for: .touchUpInside)
        buttonHeader.tintColor = UIColor.white
        buttonHeader.layer.cornerRadius = 10
        
        // Se añade el botón a la vista de la sección
        viewHeader.addSubview(buttonHeader)
        viewHeader.backgroundColor = backgroundColor
        
        // Asignación de constraints del botón de la sección
        buttonHeader.translatesAutoresizingMaskIntoConstraints = false
        buttonHeader.centerXAnchor.constraint(equalTo: viewHeader.centerXAnchor).isActive = true
        buttonHeader.centerYAnchor.constraint(equalTo: viewHeader.centerYAnchor).isActive = true
        buttonHeader.widthAnchor.constraint(equalTo: viewHeader.widthAnchor).isActive = true
        buttonHeader.heightAnchor.constraint(equalTo: viewHeader.heightAnchor).isActive = true
        
        // Asignación de las constraints de la imagen del botón (flechita de indicación)
        buttonHeader.imageView?.translatesAutoresizingMaskIntoConstraints = false
        buttonHeader.imageView?.trailingAnchor.constraint(equalTo: buttonHeader.trailingAnchor, constant: -15).isActive = true
        buttonHeader.imageView?.centerYAnchor.constraint(equalTo: buttonHeader.centerYAnchor).isActive = true
        buttonHeader.imageView?.heightAnchor.constraint(equalToConstant: 12).isActive = true
        buttonHeader.imageView?.widthAnchor.constraint(equalToConstant: 12).isActive = true
                
        return viewHeader
    }
    
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
        if dataTitle[section].contains("\n") {
            return 60
        } else {
            return 40
        }
        
    }
    
    func numberOfSections(in tableView: UITableView) -> Int {
        return dataTitle.count
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return arrayVacio[section].count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "cell", for: indexPath) as! DetailOfficialContentCell
        cell.labelDescription.text = arrayVacio[indexPath.section][indexPath.row]
        cell.selectionStyle = .none
        return cell
    }
    
    func tableView(_ tableView: UITableView, viewForFooterInSection section: Int) -> UIView? {
        let view : UIView = UIView ()
        view.backgroundColor = backgroundColor
        return view
    }
    
    func tableView(_ tableView: UITableView, heightForFooterInSection section: Int) -> CGFloat {
        return 12.5
    }
    
    

    // MARK: - Método que gestiona el despliegue y repliegue del tableView
    // ...................................................................
    
    @objc func handleDropDown (sender : UIButton) {
        
        for i in 0...(dataTitle.count-1) {
            if sender.titleLabel?.text == dataTitle[i] {
                if (images[i] == upArrow) {
                    images[i] = downArrow
                    state = downArrow
                    sender.setImage(UIImage(systemName: images[i])!, for: .normal)
                    print ("¡¡¡ REPLEGAMOS !!!")
                    for _ in 0...dataDescription[sender.tag].count-1 {
                        let indexPath = IndexPath(row: arrayVacio[sender.tag].count-1, section: sender.tag)
                        arrayVacio[sender.tag].remove(at: indexPath.row)
                        tableView.deleteRows(at: [indexPath], with: .fade)
                    }
                } else if (images[i] == downArrow) {
                    images[i] = upArrow
                    state = upArrow
                    sender.setImage(UIImage(systemName: images[i])!, for: .normal)
                    print ("¡¡¡ DESPLEGAMOS !!!")
                    for x in 0...dataDescription[sender.tag].count-1 {
                        arrayVacio[sender.tag].append(dataDescription[sender.tag][x])
                        let indexPath = IndexPath(row: arrayVacio[sender.tag].count-1, section: sender.tag)
                        tableView.beginUpdates()
                        tableView.insertRows(at: [indexPath], with: .fade)
                        tableView.endUpdates()
                    }
                }
            }
        }
        
        images.remove(at: sender.tag)
        images.insert(state, at: sender.tag)
        print (images)
    }
    

    // MARK: - Variables para almacenar el contenido oficial (títulos y descripciones)
    // ...............................................................................

    // Contenido oficial del TEMA 1
    let titleSubChapterT1 : [String] = ["1.1.  Casco", "1.2.  Estructura", "1.3.  Equipo de fondeo", "1.4.  Timón", "1.5.  Hélice", "1.6.  Dimensiones", "1.7.  Terminología"]
    let descriptionSubChapterT1 : [[String]] = [
        ["1.1.1. Casco y cubierta", "1.1.2. Proa y popa", "1.1.3. Línea y plano de crujía, para definir: estribor y babor", "1.1.4. Costados, amura, través y aleta", "1.1.5. Plano de flotación, para definir: obra viva (carena) y obra muerta", "1.1.6. Bañera e imbornales", "1.1.7. Escotillas, escotilla principal", "1.1.8. Lumbreras y manguerotes ventilación", "1.1.9. Portillos y tragaluces", "1.1.10. Pasamanos, candeleros y guardamancebos"],
        ["1.2.1. Quilla, roda, codaste, cuadernas, baos, borda, regala, mamparos, plan y sentina", "1.2.2. Grifos de fondo", "1.2.3. Bombas de achique"],
        ["1.3.1. Molinete: barbotén, embrague y freno", "1.3.2. Línea de fondeo. Grillete de unión. Partes del ancla sin cepo", "1.3.3. Forma del ancla de arado, del ancla Danforth y del rezón", "1.3.4. En referencia al ancla y la maniobra de fondeo, definiciones de: virar, filar, a la pendura, a pique, levar, zarpar, clara y libre"],
        ["1.4.1. Partes del timón: caña o rueda, mecha, limera, guardines y pala"],
        ["1.5.1. Partes de la hélice: eje, bocina, núcleo, palas y capacete", "1.5.2. Hélice dextrógira y hélice levógira", "1.5.3. Hélices gemelas de giro al exterior", "1.5.4. Hélice de palas abatibles"],
        ["1.6.1. Eslora, manga y manga máxima, puntal, franco bordo, calado de proa, calado de popa, calado medio y asiento", "1.6.2. Desplazamiento máximo en embarcaciones de recreo"],
        ["1.7.1. Escorar y adrizar. Barlovento y sotavento"],
    ]
    
    
    // Contenido oficial del TEMA 2
    let titleSubChapterT2 : [String] = ["2.1. Elementos de amarre", "2.2. Nudos", "2.3. Fondeo"]
    let descriptionSubChapterT2 : [[String]] = [
        ["2.1.1. Definiciones de: noray, muertos, boyas, defensas, bichero, chicote, seno, firme y gaza, guía-cabos, roldana, bitas y cornamusas"],
        ["2.2.1. Indicar para qué se emplean los siguientes nudos: llano, vuelta de rezón, ballestrinque y as de guía"],
        ["2.3.1. Elección del lugar de fondeo y del tenedero", "2.3.2. Fondeo a la gira con un ancla: maniobra, longitud del fondeo, círculo de borneo", "2.3.3. Garreo", "2.3.4. Vigilancia durante el fondeo: marcas, alarma de sonda", "2.3.5. Orinque", "2.3.6. Maniobra de levar el ancla"]
    ]
    
    
    // Contenido oficial del TEMA 3
    let titleSubChapterT3 : [String] = ["3.1. Estabilidad", "3.2. Comprobaciones antes de \nhacerse a la mar", "3.3. Medidas a tomar a bordo con mal tiempo", "3.4. Tormentas eléctricas", "3.5. Baja visibilidad", "3.6. Aguas someras", "3.7. Material de seguridad", "3.8. Hombre al agua", "3.9. Remolque", "3.10. Salvamento marítimo"]
    let descriptionSubChapterT3 : [[String]] = [
        ["3.1.1. Definiciones de:" + "\n" + "- Movimiento de balance y cabezada" + "\n" + "- Estabilidad estática transversal y longitudinal (sin entrar en su estudio)", "3.1.2. Forma de gobernar para evitar balances y cabezadas", "3.1.3. Importancia de no atravesarse a la mar"],
        ["3.2.1. Ser consciente de la necesidad e importancia de realizar una serie de comprobaciones previas a la salida a la mar", "3.2.2. Poder enumerar las siguientes: niveles de aceite, filtros decantación de agua e impurezas, líquido refrigerante, refrigeración, correa del alternador, nivel de combustible, agua dulce, baterías, luces de navegación, equipo de radio, estanqueidad, sistema de gobierno y propulsión, ausencia de gases explosivos, fugas de aceite o combustible, parte meteorológico, existencia y estado de elementos de seguridad (chalecos, aros salvavidas, equipo pirotécnico y extintores)"],
        ["3.3.1. Estiba y trinca a son de mar", "3.3.2. Revisión de todas las aberturas. Cierre de grifos de fondo", "3.3.3. Derrota a seguir: capear o correr el temporal", "3.3.4. Riesgos de una costa a sotavento"],
        ["3.4.1. Protección de las tormentas eléctricas e influencia en la aguja"],
        ["3.5.1. Precauciones en la navegación con niebla, el reflector radar, evitar el tráfico marítimo.", "3.5.2. Precauciones para la navegación nocturna"],
        ["3.6.1. Definición de aguas someras", "3.6.2. Precauciones en la navegación en aguas someras"],
        ["3.7.1. Descripción, recomendaciones de uso y estiba de los siguientes elementos:" + "\n" + "- Chalecos salvavidas" + "\n" + "- Arneses y líneas de vida" + "\n" + "- Aros salvavidas y balsas salvavidas" + "\n" + "- Bengalas de mano, cohetes con luz roja y paracaídas y señales fumígenas flotantes" + "\n" + "- Espejo de señales y bocina de niebla" + "\n" + "- Extintores portátiles y baldes contra-incendios"],
        ["3.8.1. Prevención para evitar una situación de hombre al agua: arnés de seguridad, iluminación", "3.8.2. Hombre al agua: librar la hélice, señalización del náufrago, balizamiento individual, lanzamiento de ayudas", "3.8.3. Maniobras de aproximación cuando se ve al náufrago: maniobra de Anderson y maniobra de Boutakow", "3.8.4. Maniobras de búsqueda cuando no se ve al náufrago: exploración en espiral cuadrada y exploración por sectores", "3.8.5. Uso del sistema de navegación por satélite (GNSS) en caso de caída de hombre al agua", "3.8.6. Precauciones durante la recogida", "3.8.7. Reanimación de un náufrago: respiración boca a boca y masaje cardiaco", "3.8.8. Hipotermia: concepto y medidas a tomar"],
        ["3.9.1. Maniobra de aproximación, dar y tomar el remolque, forma de navegar el remolcador y el remolcado"],
        ["3.10.1. Además de mediante el uso de la estación radio de a bordo, forma de contactar con S.M: 112 y 900 202 202."]
    ]
    
    
    // Contenido oficial del TEMA 4
    let titleSubChapterT4 : [String] = ["4.1. Normas que afectan a las embarcaciones de recreo", "4.2. Limitaciones a la navegación", "4.3. Buzos y bañistas", "4.4. Prevención de la contaminación", "4.5. Pabellón nacional", "4.6. Salvamento", "4.7. Protección de espacios \nnaturales del medio marino"]
    let descriptionSubChapterT4 : [[String]] = [
        ["4.1.1. Respecto al tráfico marítimo y navegación interior en los puertos"],
        ["4.2.1. En lugares próximos a la costa", "4.2.2. En playas no balizadas", "4.2.3. En playas balizadas y canales de acceso", "4.2.4. En reservas marinas"],
        ["4.3.1. Precauciones a tomar ante la presencia de:" + "\n" + "- Bañistas." + "\n" + "- Buzos. Banderas “Alfa” del código Internacional de señales y “Bravo” modificada"],
        ["4.4.1. Idea sobre el régimen de descargas y vertidos al mar de las embarcaciones de recreo, según la Orden FOM 1144/2003, de 28 de abril, o aquella que la pudiera sustituir", "4.4.2. Idea sobre el régimen de entrega de desechos generados por las embarcaciones de recreo, según el Real Decreto 1381/2002, de 20 de diciembre, o aquel que lo pudiera sustituir", "4.4.3. Régimen de vertido de basuras al mar según el capítulo V del Convenio Internacional MARPOL:" + "\n" + "- Ámbito de aplicación (regla 2)." + "\n" + "- Prohibición general de la descarga de basuras en el mar (regla 3)." + "\n" + "- Descarga de basuras fuera de las zonas especiales (regla 4)." + "\n" + "- Descarga de basuras dentro de zonas especiales, caso concreto del Mediterráneo (regla 6)", "4.4.4. Responsabilidad del patrón por contaminación", "4.4.5. Conducta ante un avistamiento de contaminación durante la navegación: obligación de informar"],
        ["4.5.1. Bandera nacional en embarcaciones de recreo", "4.5.2. Uso de la bandera de la Comunidad Autónoma"],
        ["4.6.1. Obligación de prestar auxilio a las personas según el párrafo 1, regla 33, capítulo V, del convenio internacional SOLAS"],
        ["4.7.1. Zonas Especialmente Protegidas de Importancia para el Mediterráneo (ZEPIM). Caso concreto en el Mediterráneo: praderas de Posidonia Oceánica."]
    ]
    
    
    // Contenido oficial del TEMA 5
    let titleSubChapterT5 : [String] = ["5.1. Normativa IALA"]
    let descriptionSubChapterT5 : [[String]] = [
        ["5.1.1. Marcas laterales región A, marcas cardinales, marcas de peligro aislado, marcas de aguas navegables y marcas especiales.", "** En cada Resolución de Convocatorias se especificará la normativa IALA en la que se basarán los exámenes **"]
    ]
    
    
    // Contenido oficial del TEMA 6
    let titleSubChapterT6 : [String] = ["6.1. Generalidades", "6.2. Reglas de rumbo y de gobierno", "6.3. Luces y marcas", "6.4. Señales acústicas y luminosas", "6.5. Señales de peligro", "QUEDA EXPRESAMENTE EXCLUIDO:"]
    let descriptionSubChapterT6 : [[String]] = [
        ["6.1.1. Reglas 1 a 3"],
        ["6.2.1. Reglas 4 a 19"],
        ["6.3.1. Reglas 20, 21 y 23 a 31"],
        ["6.4.1. Reglas 32 a 37"],
        ["6.5.1. Anexo IV"],
        ["6.6.1. Regla 22 y Anexos I, II y III." + "\n" + "- Cualquier interpretación que no se ajuste a lo escrito textualmente en el Reglamento"]
    ]
    
    
    // Contenido oficial del TEMA 7
    let titleSubChapterT7 : [String] = ["7.1. Amarras", "7.2. Gobierno con caña o rueda", "7.3. Maniobras"]
    let descriptionSubChapterT7 : [[String]] = [
        ["7.1.1. Definiciones de:" + "\n" + "- Encapillar una gaza al noray, amarrar por seno, tomar vueltas y hacer firme" + "\n" + "- Cobrar, virar, tesar, templar, amollar, lascar, arriar y largar" + "\n" + "- Adujar" + "\n" + "- Largo, través, esprín y codera", "7.1.2. Descripción de los efectos producidos al cobrar de cada una de las amarras, estando el barco atracado costado al muelle", "7.1.3. Utilización de las amarras según viento y corriente"],
        ["7.2.1. Definiciones de: velocidad de gobierno y arrancada", "7.2.2. Nombrar las tres fases de la curva de evolución en marcha avante y tener conocimiento de la importancia del rabeo de la popa", "7.2.3. Describir:" + "\n" + "- El efecto de la corriente de expulsión y de la presión lateral de las palas sobre una embarcación que se encuentre, parada sin arrancada, con el timón a la vía y da máquina atrás." + "\n" + "- El efecto combinado hélice–timón con arrancada avante y máquina atrás" + "\n" + "- La ciaboga con una hélice" + "\n" + "- La ciaboga con dos hélices gemelas de giro al exterior" + "\n" + "- Agentes que influyen en la maniobra:" + "\n" + "* Viento, corriente y olas" + "\n" + "* Concepto de abatimiento y deriva" + "\n" + "* Libre a sotavento"],
        ["7.3.1. Atraque y desatraque en punta (proa y popa) y costado al muelle", "7.3.2. Amarrar: cabos que deben darse, forma de hacerlos firme y orden en el que hacerlo, para los tipos de atraque del punto anterior", "7.3.3. Desamarrar: orden en que largar los cabos de acuerdo al tipo de atraque y maniobra a realizar para desatracar", "7.3.4. Abarloarse a otra embarcación, independientemente del tipo que sean ambas", "7.3.5. Amarrar a una boya"]
    ]
    
    
    // Contenido oficial del TEMA 8
    let titleSubChapterT8 : [String] = ["8.1. Accidentes personales", "8.2. Varada incoluntaria", "8.3. Abordaje", "8.4. Vías de agua e inundación", "8.5. Prevención de incendios y \nexplosiones", "8.6. Abandono de la embarcación"]
    let descriptionSubChapterT8 : [[String]] = [
        ["8.1.1. Tratamiento de urgencia de heridas, contusiones, hemorragias, quemaduras (incluidas las originadas por el sol), insolación y mal de mar o mareo", "8.1.2. Además de mediante el uso de la estación radio de a bordo, forma de contactar con el servicio Radio-Médico español: telefonía móvil. Horarios", "8.1.3. Importancia de llevar la guía médica del ISM a bordo y cómo conseguirla"],
        ["8.2.1. Descripción de las medidas a tomar para salir de la embarrancada"],
        ["8.3.1. Medidas a tomar y reconocimiento de averías"],
        ["8.4.1. Puntos de mayor riesgo, bocina, limera del timón, orificios y grifos de fondo, manguitos, abrazaderas", "8.4.2. Medidas a tomar tras la vía de agua: achique con bomba manual y/o eléctrica (uso e importancia de un buen mantenimiento). Taponamiento con espiches y colchonetas"],
        ["8.5.1. Lugares de riesgo: cocinas, cámaras de motores, tomas de combustible, baterías, instalación eléctrica, pañol o cofre de pinturas", "8.5.2. Factores que han de concurrir para que se produzca un incendio: teoría del tetraedro del fuego", "8.5.3. Clasificación UNE de los incendios, definir las siguientes clases: A, B, C y F", "8.5.4. El agua como agente extintor, precauciones", "8.5.5. Extintores: extintores válidos para la extinción de incendios clase B, utilización básica de un extintor de polvo seco, uso óptimo y como atacar las llamas. Comprobaciones básicas periódicas de mantenimiento", "8.5.6. Modo de proceder al declararse un incendio", "8.5.7. Procedimientos de extinción: conocimiento básico de las técnicas de enfriamiento, sofocación, dispersión o aislamiento del combustible e inhibición de la reacción en cadena", "8.5.8. Socairear el fuego, rumbo para que el viento aparente sea cero"],
        ["8.6.1. Medidas a tomar antes de abandonar la embarcación", "8.6.2. Forma de abandonar la embarcación: supuesto de un abandono sin disponibilidad de balsa salvavidas", "8.6.3. Permanencia en el agua después de un abandono", "8.6.4. Uso de las señales pirotécnicas"]
    ]
    
    
    // Contenido oficial del TEMA 9
    let titleSubChapterT9 : [String] = ["9.1. Importancia del tiempo meteor.\nen la seguridad de la navegación", "9.2. Presión atmosférica", "9.3. Temperatura", "9.4. Borrascas y anticiclones", "9.5. Viento", "9.6. Brisas costeras", "9.7. Mar", "QUEDA EXPRESAMENTE EXCLUIDO:"]
    let descriptionSubChapterT9 : [[String]] = [
        ["9.1.1. Formas de obtener la previsión meteorológica"],
        ["9.2.1. Definición, unidades de medida y valor normal", "9.2.2. Medida de la presión atmosférica con el barómetro aneroide", "9.2.3. Definición de líneas isobaras"],
        ["9.3.1. Definición y unidades de medida (escala centígrada)"],
        ["9.4.1. Definición", "Circulación general del viento en el hemisferio norte en estas formaciones", "9.4.2. Trayectoria de las borrascas"],
        ["9.5.1. Definiciones de: rolar, caer, refrescar, racha y calmar", "9.5.2. Anemómetro, veletas y catavientos", "9.5.3. Viento real, relativo y aparente: definiciones, sin cálculos", "9.5.4. Utilidad de la escala de Beaufort y necesidad de llevarla a bordo"],
        ["9.6.1. Terral y virazón"],
        ["9.7.1. Conceptos de: intensidad, persistencia y fecht", "9.7.2. Utilidad de la escala de Douglas y necesidad de llevarla a bordo"],
        ["9.8.1. Memorizar las escalas de Beaufort y de Douglas"]
    ]
    
    
    // Contenido oficial del TEMA 10
    let titleSubChapterT10 : [String] = ["10.1. Esfera terrestre", "10.2. Cartas mercatorianas", "10.3. Publicaciones náuticas", "10.4. Unidad de distancia. Unidad de velocidad", "10.5. Declinación magnética", "10.6. Aguja náutica", "10.7. Corrección total", "10.8. Rumbos", "10.9. Líneas de posición", "10.10. Marcación", "10.11. Ayudas a la navegación", "10.12. Mareas", "10.13. Viento y corriente", "QUEDA EXPRESAMENTE EXCLUIDO:"]
    let descriptionSubChapterT10 : [[String]] = [
        ["Definiciones de: eje, polos, Ecuador, meridianos y paralelos, meridiano cero, meridiano del lugar, latitud y longitud"],
        ["Cartas de navegación costera, recalada, portulanos y cartuchos", "Información que proporcionan las cartas: accidentes de la costa, accidentes del terreno, puntos de referencia, luces, marcas, balizas, peligros, zonas prohibidas", "Signos y abreviaturas más importantes utilizadas en las cartas náuticas: faros, sondas, naturaleza del fondo, veriles, declinación magnética"],
        ["Somera descripción de los derroteros, guías náuticas para la navegación de recreo y libros de faros"],
        ["Milla náutica: definición y su equivalencia en metros", "Escalas de latitudes y longitudes en las cartas mercatorianas", "Forma de medir las distancias en la carta", "Nudo: definición", "Corredera, qué es y para qué sirve", "Coeficiente de corredera: su aplicación", "Sonda, qué es y para qué sirve", "Concepto de Hora Reloj Bitácora"],
        ["Definición", "Forma de actualizarla"],
        ["Descripción sucinta de la aguja náutica. Instalación, perturbaciones", "Definición del desvío de la aguja", "Concepto de la tablilla de desvíos"],
        ["Definición", "Cálculo a partir de la declinación y el desvío"],
        ["Definición de rumbo verdadero, magnético y de aguja", "Relación entre ellos", "Forma de medir los rumbos: circular y cuadrantal", "Convertir un valor cuadrantal a circular (y no al revés)"],
        ["Definición de: enfilaciones, oposiciones, demoras, distancias y veriles", "Obtención de líneas de posición con la aguja y conversión de éstas en verdaderas para su trazado en la carta", "Empleo de las enfilaciones, demoras y sondas como líneas de posición de seguridad", "Condiciones que han de darse para que las líneas de posición sean fiables"],
        ["Definición", "Forma de medirla: circular y semicircular", "Relación entre rumbo, demora y marcación"],
        ["Marcas. Luces y señales marítimas: faros y balizas"],
        ["Concepto y utilidad de su conocimiento", "Referencia de las sondas, definiciones de: cero hidrográfico, sonda en el LAT, amplitud de la marea, duración de la marea", "Influencia de fenómenos meteorológicos: viento y presión atmosférica"],
        ["Influencia del viento y la corriente en la navegación. Conceptos de abatimiento y deriva; su efecto sobre la embarcación dependiendo de la obra viva y muerta de ésta"],
        ["Memorizar las escalas de las cartas", "Tipos de correderas y su funcionamiento"]
    ]
    
    
    // Contenido oficial del TEMA 11
    let titleSubChapterT11 : [String] = ["11.1. Coordenadas", "11.2. Distancia y rumbo directo", "11.3. Corrección total", "11.4. Rumbo verdadero y de aguja (en ausencia de viento y corriente)", "11.5. Situación de estima (en\nausencia de viento y corriente)", "11.6. Situación verdadera", "11.7. Mareas"]
    let descriptionSubChapterT11 : [[String]] = [
        ["Dado un punto en la carta, conocer sus coordenadas", "Dadas las coordenadas de un punto, situarlo en la carta"],
        ["Forma de medir las distancias sobre la carta", "Forma de trazar y medir los rumbos"],
        ["Cálculo de la corrección total a partir de una enfilación u oposición", "Cálculo de la corrección total a partir del desvío y la declinación magnética (dato aportado u obtenido de la carta)"],
        ["Dadas la situación de salida y de llegada: calcular el rumbo de aguja", "Dadas la situación de salida, la hrb (de la salida), situación de llegada y la velocidad de la embarcación: calcular el rumbo de aguja y la hora de llegada", "Dada la situación de salida: calcular el rumbo de aguja para pasar a una distancia determinada de la costa o peligro. (Excluida la distancia mínima)"],
        ["Dada la situación de salida, la Hrb, la velocidad de la embarcación y el rumbo de aguja: calcular la situación de estima a una hora determinada"],
        ["Obtener la situación por la intersección de dos de las siguientes líneas de posición simultáneas: distancias, línea isobática, enfilaciones, oposiciones y demoras", "Para obtener la situación con demoras, los datos podrán ser: demora verdadera, demora de aguja y/o marcación, teniendo que convertir las dos últimas en demoras verdaderas para su trazado en la carta"],
        ["Cálculo de la sonda en el momento de la pleamar y en el de la bajamar (se preguntará como cuestión independiente de los ejercicios de navegación, referida siempre a la hora del anuario)"]
    ]

}

extension CALayer {

    func addBorder(edge: UIRectEdge, color: UIColor, thickness: CGFloat) {

        let border = CALayer()

        switch edge {
        case UIRectEdge.top:
            border.frame = CGRect(x: 0, y: 0, width: self.frame.height, height: thickness)
            break
        case UIRectEdge.bottom:
            border.frame = CGRect(x: 0, y: self.frame.height - thickness, width: UIScreen.main.bounds.width-24, height: thickness)
            break
        case UIRectEdge.left:
            border.frame = CGRect(x: 0, y: 0, width: thickness, height: self.frame.height)
            break
        case UIRectEdge.right:
            border.frame = CGRect(x: self.frame.width - thickness, y: 0, width: thickness, height: self.frame.height)
            break
        default:
            break
        }

        border.backgroundColor = color.cgColor

        self.addSublayer(border)
    }

}



