//
//  OfficialContent.swift
//  PER
//
//  Created by Conrado on 07/05/2020.
//  Copyright © 2020 Conrado. All rights reserved.
//

import UIKit
import CarbonKit
import APESuperHUD

class OfficialContent: UIViewController, CarbonTabSwipeNavigationDelegate {
    
    @IBOutlet weak var menuButton: UIBarButtonItem!
    
    
    var carbonTabSwipeNavigation = CarbonTabSwipeNavigation ()
    
    override func viewDidLoad() {
        super.viewDidLoad()
            
        
        
        // Se asigna el diseño de la barra de navegación
        setDesignNavBar (navigationItem: navigationItem, appearance: UINavigationBarAppearance())
        
        // Side menu
        menuButton.target = self.revealViewController()
        menuButton.action = #selector(SWRevealViewController.revealToggle(_:))
        self.view.addGestureRecognizer(self.revealViewController().panGestureRecognizer())
        self.revealViewController().rearViewRevealWidth = fullWidthScreen * 0.85

        print ("He aterrizado en el controlador del temario oficial")
        
        carbonTabSwipeNavigation = CarbonTabSwipeNavigation (items: chaptersNumber, delegate: self)
        carbonTabSwipeNavigation.insert(intoRootViewController: self)
        
        self.carbonTabSwipeNavigation.setIndicatorHeight(4)
        self.carbonTabSwipeNavigation.toolbar.barTintColor = mainBlueColor
        self.carbonTabSwipeNavigation.toolbar.isTranslucent = false
        self.carbonTabSwipeNavigation.setNormalColor(UIColor.white, font: UIFont(name: "IBMPlexSans-Medium", size: 16)!)
        self.carbonTabSwipeNavigation.setSelectedColor(UIColor.white, font: UIFont(name: "IBMPlexSans-Bold", size: 19)!)
        self.carbonTabSwipeNavigation.setIndicatorColor(UIColor.white)
    }
    
    
    
    func carbonTabSwipeNavigation(_ carbonTabSwipeNavigation: CarbonTabSwipeNavigation, viewControllerAt index: UInt) -> UIViewController {
                
        let nextVC = self.storyboard!.instantiateViewController(withIdentifier: "DetailOfficialContent") as! DetailOfficialContent
        
        if index == 0 {  nextVC.indexChapter = Int(index)  }
        else if index == 1 {  nextVC.indexChapter = Int(index)  }
        else if index == 2 {  nextVC.indexChapter = Int(index)  }
        else if index == 3 {  nextVC.indexChapter = Int(index)  }
        else if index == 4 {  nextVC.indexChapter = Int(index)  }
        else if index == 5 {  nextVC.indexChapter = Int(index)  }
        else if index == 6 {  nextVC.indexChapter = Int(index)  }
        else if index == 7 {  nextVC.indexChapter = Int(index)  }
        else if index == 8 {  nextVC.indexChapter = Int(index)  }
        else if index == 9 {  nextVC.indexChapter = Int(index)  }
        else if index == 10 {  nextVC.indexChapter = Int(index)  }
        
        return nextVC
    }
    
    
    @IBAction func infoOfficialContent(_ sender: UIBarButtonItem) {
        let alertInfo = UIAlertController(title: "TEMARIO OFICIAL del PER", message: "\nToda esta información ha sido obtenida de la única FUENTE OFICIAL disponible: el 'Real Decreto 875/2014, de 10 de octubre, por el que se regulan las titulaciones náuticas para el gobierno de las embarcaciones de recreo' publicado en el BOE núm. 247 de 2014 por el MINISTERIO DE FOMENTO. \n\n En esta aplicación se muestra información del examen teórico de la titulación de manera resumida y esquematizada pero, igualmente, si deseas tener acceso al BOE completo puedes clicar sobre alguna de las siguientes opciones:", preferredStyle: .alert)
        let actionDownload = UIAlertAction(title: "Descargar BOE en PDF", style: .default, handler: { action in
            
            // - - - - -
            HUDAppearance.backgroundColor = secondaryBlueColor.withAlphaComponent(0.5)
            HUDAppearance.titleFont = UIFont.systemFont(ofSize: 15, weight: .bold)
            HUDAppearance.messageFont = UIFont.systemFont(ofSize: 15, weight: .regular)
            // HUDAppearance.animateInTime = 2
            HUDAppearance.hudSize = CGSize(width: 170, height: 120)
            // HUDAppearance.shadow = true
            HUDAppearance.cancelableOnTouch = false
            let hudViewController = APESuperHUD(style: .loadingIndicator(type: .standard), title: "Descargando PDF...", message: "")
            self.present(hudViewController, animated: true)
            
            let urlString = "https://boe.es/boe/dias/2014/10/11/pdfs/BOE-A-2014-10344.pdf"
            let url = URL(string: urlString)
            let fileName = String((url!.lastPathComponent)) as NSString
            // Create destination URL
            let documentsUrl:URL =  (FileManager.default.urls(for: .documentDirectory, in: .userDomainMask).first as URL?)!
            let destinationFileUrl = documentsUrl.appendingPathComponent("\(fileName)")
            //Create URL to the source file you want to download
            let fileURL = URL(string: urlString)
            let sessionConfig = URLSessionConfiguration.default
            let session = URLSession(configuration: sessionConfig)
            let request = URLRequest(url:fileURL!)
            let task = session.downloadTask(with: request) { (tempLocalUrl, response, error) in
                if let tempLocalUrl = tempLocalUrl, error == nil {
                    // Success
                    if let statusCode = (response as? HTTPURLResponse)?.statusCode {
                        print("Successfully downloaded. Status code: \(statusCode)")
                    }
                    do {
                        // Borrar de destinationFileUrl
                        try FileManager.default.removeItem(at: destinationFileUrl)
                        try FileManager.default.copyItem(at: tempLocalUrl, to: destinationFileUrl)
                        do {
                            //Show UIActivityViewController to save the downloaded file
                            let contents  = try FileManager.default.contentsOfDirectory(at: documentsUrl, includingPropertiesForKeys: nil, options: .skipsHiddenFiles)
                            for indexx in 0..<contents.count {
                                if contents[indexx].lastPathComponent == destinationFileUrl.lastPathComponent {
                                    let activityViewController = UIActivityViewController(activityItems: [contents[indexx]], applicationActivities: nil)
                                    DispatchQueue.main.async {
                                        hudViewController.dismiss(animated: false)
                                        self.present(activityViewController, animated: true, completion: nil)
                                    }
                                }
                            }
                        }
                        catch (let err) {
                            print("error: \(err)")
                        }
                    } catch (let writeError) {
                        print("Error creating a file \(destinationFileUrl) : \(writeError)")
                    }
                } else {
                    print("Error took place while downloading a file. Error description: \(error?.localizedDescription ?? "")")
                }
            }
            task.resume()
        })
        let actionWeb = UIAlertAction(title: "Ver BOE en línea", style: .default, handler: { action in
            self.performSegue(withIdentifier: "boe_webView", sender: nil)
        })
        let actionCancel = UIAlertAction(title: "Cancelar", style: .destructive, handler: nil)
        alertInfo.addAction(actionDownload)
        alertInfo.addAction(actionWeb)
        alertInfo.addAction(actionCancel)
        present(alertInfo, animated: true)
    }
    
    
    

}
