//
//  BookCollectionViewCell.swift
//  PER
//
//  Created by Conrado on 13/04/2020.
//  Copyright © 2020 Conrado. All rights reserved.
//

import UIKit

class BookCollectionViewCell: UICollectionViewCell {
    
    @IBOutlet weak var imageBook: UIImageView!
    @IBOutlet weak var numberBook: UILabel!
    @IBOutlet weak var WPshareButton: UIButton!
    @IBOutlet weak var TWShareButton: UIButton!
    @IBOutlet weak var MAILShareButton: UIButton!
    @IBOutlet weak var titleBook: UILabel!
    @IBOutlet weak var priceBook: UILabel!
    @IBOutlet weak var authorBook: UILabel!
    @IBOutlet weak var viewButtonBuyBook: UIView!
    @IBOutlet weak var imageCarAmazon: UIImageView!
    @IBOutlet weak var labelBuyAmazon: UILabel!
    @IBOutlet weak var buttonBuyBook: UIButton!
    
    var heightCell : CGFloat = 0.0
    var widthCell : CGFloat = 0.0
    var heightImage : CGFloat = 0.0
    var widthImage : CGFloat = 0.0
    


    func constraintsElements (heightCell : CGFloat, widthCell : CGFloat) {
        
        heightImage = heightCell * 0.62
        widthImage = heightImage / 1.6
        
        // Imagen de libro
        imageBook.frame = CGRect (x: (widthCell - widthImage)/2, y: heightCell * 0.03, width: widthImage, height: heightImage)
        imageBook.backgroundColor = .gray
        imageBook.clipsToBounds = true
        imageBook.layer.cornerRadius = 2
        
        // Número de libro
        let initPointNumber = imageBook.frame.origin.x + imageBook.frame.size.width
        let marginSpaceNumber = widthCell - initPointNumber
        let widthLabelNumber = marginSpaceNumber * 0.775
        
        numberBook.frame = CGRect (
            x: widthCell - widthLabelNumber - (marginSpaceNumber * 0.10),
            y: heightCell * 0.03,
            width: widthLabelNumber,
            height: 25
        )
        // numberBook.backgroundColor = .lightGray
        numberBook.clipsToBounds = true
        numberBook.layer.cornerRadius = 12
        
        // Botón de compartir por whatsapp
        let widthButtonShare = marginSpaceNumber / 2
        WPshareButton.frame = CGRect (
            x: widthCell - widthButtonShare - 1,
            y: numberBook.frame.origin.y + numberBook.frame.size.height + 30,
            width: widthButtonShare,
            height: widthButtonShare
        )
        // WPshareButton.backgroundColor = .orange
        WPshareButton.isHidden = true
        
        // Botón de compartir por twitter
        TWShareButton.frame = CGRect (
            x: widthCell - widthButtonShare - 1,
            y: WPshareButton.frame.origin.y + WPshareButton.frame.size.height + 2,
            width: widthButtonShare,
            height: widthButtonShare
        )
        // TWShareButton.backgroundColor = .green
        TWShareButton.isHidden = true
        
        // Botón de compartir por e-mail
        MAILShareButton.frame = CGRect (
            x: widthCell - widthButtonShare - 1,
            y: TWShareButton.frame.origin.y + TWShareButton.frame.size.height + 2,
            width: widthButtonShare,
            height: widthButtonShare
        )
        // MAILShareButton.backgroundColor = .blue
        MAILShareButton.isHidden = true
        
        
        // Titulo
        titleBook.frame = CGRect (x: widthCell * 0.05, y: heightCell * 0.66, width: widthCell * 0.90, height: heightCell * 0.13)
        // titleBook.backgroundColor = .orange
        
        // Precio
        priceBook.frame = CGRect (x: widthCell * 0.65, y: heightCell * 0.80, width: widthCell * 0.30, height: heightCell * 0.06)
        // priceBook.backgroundColor = .green
        
        // Autor
        authorBook.frame = CGRect (x: widthCell * 0.05, y: heightCell * 0.785, width: widthCell * 0.60, height: heightCell * 0.06)
        // authorBook.backgroundColor = .yellow
        authorBook.attributedText = NSAttributedString(string: "por Alfonso Jordana", attributes:
        [.underlineStyle: NSUnderlineStyle.single.rawValue])
        
        // View del botón de compra
        viewButtonBuyBook.frame = CGRect (x: widthCell * 0.05, y: heightCell * 0.88, width: widthCell * 0.90, height: heightCell * 0.09)
        viewButtonBuyBook.clipsToBounds = true
        viewButtonBuyBook.layer.cornerRadius = 6
        viewButtonBuyBook.layer.borderWidth = 1
        viewButtonBuyBook.layer.borderColor = UIColor.black.cgColor
        
        // Botón del view
        buttonBuyBook.frame = CGRect (x: 0, y: 0, width: viewButtonBuyBook.frame.size.width, height: viewButtonBuyBook.frame.size.height)
        
        // Imagen del view
        imageCarAmazon.frame = CGRect (x: 0, y: viewButtonBuyBook.frame.size.height * 0.2, width: viewButtonBuyBook.frame.size.width * 0.20, height: viewButtonBuyBook.frame.size.height * 0.6)
        
        // Etiqueta del view
        labelBuyAmazon.frame = CGRect (x: viewButtonBuyBook.frame.size.width * 0.20, y: 0, width: viewButtonBuyBook.frame.size.width * 0.80, height: viewButtonBuyBook.frame.size.height)

    }
    
    
    
    @IBAction func goToBookAmazon(_ sender: UIButton) {
        print (" ... Estoy pulsando sobre el botón ... ")
        guard let url = URL(string: "http://www.as.com/") else {
             return
        }
        if UIApplication.shared.canOpenURL(url) {
             UIApplication.shared.open(url, options: [:], completionHandler: nil)
         }
    }
    
    @IBAction func WPShareButton(_ sender: UIButton) {
        print("Este es el botón de compartir por whatsapp")
    }
    
    @IBAction func TWShareButton(_ sender: UIButton) {
        print ("Este es el botón de compartir por Twitter")
    }
    
   
    @IBAction func MAILShareButton(_ sender: UIButton) {
        print ("Este es el botón de compartir por e-mail")
    }
    
    
}

