//
//  BookShopVC.swift
//  PER
//
//  Created by Conrado on 18/05/2020.
//  Copyright © 2020 Conrado. All rights reserved.
//

import UIKit

class BookShopVC: UIViewController, UICollectionViewDelegate, UICollectionViewDataSource, UICollectionViewDelegateFlowLayout {
    
    @IBOutlet weak var collectionView: UICollectionView!
    
    @IBOutlet weak var menuButton: UIBarButtonItem!
    
    
    var widthCV : CGFloat!
    var heightCV : CGFloat!
    var widthCell : CGFloat!
    var heightCell : CGFloat!
    let books : [Book] = getBooks()
    
    override func viewDidLoad() {
        
        menuButton.target = self.revealViewController()
        menuButton.action = #selector(SWRevealViewController.revealToggle(_:))
        self.view.addGestureRecognizer(self.revealViewController().panGestureRecognizer())
        self.revealViewController().rearViewRevealWidth = fullWidthScreen * 0.85
        
        // Se asigna el diseño de la barra de navegación
        setDesignNavBar(navigationItem: navigationItem, appearance: UINavigationBarAppearance())
        
        self.view.backgroundColor = backgroundColor
        self.collectionView.backgroundColor = backgroundColor
        
        widthCV = collectionView.frame.size.width
        heightCV = collectionView.frame.size.height
        widthCell = widthCV * 0.47
        heightCell = widthCell * 2.5
    }

    
    
    
    // MARK: - Métodos del collectionView
    
    func numberOfSections(in collectionView: UICollectionView) -> Int {
        return 1
    }
    
    func collectionView(_ collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        return getBooks().count
    }
    
    func collectionView(_ collectionView: UICollectionView, cellForItemAt indexPath: IndexPath) -> UICollectionViewCell {
        let cell = collectionView.dequeueReusableCell(withReuseIdentifier: "cell", for: indexPath) as! BookShopCell
        cell.constraintsElements(widthCell: widthCell, heightCell: heightCell)
        cell.imageBook.image = UIImage(named: books[indexPath.row].image)
        cell.titleBook.text = books[indexPath.row].title
        cell.priceBook.text = books[indexPath.row].price
        cell.buyAmazon.addTarget(self, action: #selector(goToAmazon(_ :)), for: .touchUpInside)
        cell.backgroundColor = backgroundColor
        return cell
    }
    
    // Asignación de altura y anchura de cada celda/item
    func collectionView(_ collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, sizeForItemAt indexPath: IndexPath) -> CGSize {
        return CGSize(width: widthCell, height: heightCell)
    }
    
    // Asignación de margen izquierdo y derecho entre líneas de Collection View
    func collectionView(_ collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, minimumLineSpacingForSectionAt section: Int) -> CGFloat {
        return 10
    }
    
    
    
    @objc func goToAmazon (_ sender : UIButton) {
        if let indexPath = self.collectionView.indexPathForButtonCollectionView(sender) {
            if let url = URL(string: links[indexPath.row]) {
                UIApplication.shared.open(url)
            }
        }
    }
    
    
    
    
}

