//
//  CommonData.swift
//  PER
//
//  Created by Conrado on 28/02/2020.
//  Copyright © 2020 Conrado. All rights reserved.
//

import Foundation
import UIKit
import SQLite
import Firebase


// Preguntas almacenadas
var questionsT1 : [Question]!
var questionsT2 : [Question]!
var questionsT3 : [Question]!
var questionsT4 : [Question]!
var questionsT5 : [Question]!
var questionsT6 : [Question]!
var questionsT7 : [Question]!
var questionsT8 : [Question]!
var questionsT9 : [Question]!
var questionsT10 : [Question]!
var questionsT11 : [Question]!


// MARK: - Paleta de colores

let mainBlue = UIColor(red: 0.0/255.0, green: 67.0/255.0, blue: 130.0/255.0, alpha: 1.0)
// - - - -
let mainBlueColor = UIColor(red: 0.0/255.0, green: 49.0/255.0, blue: 83.0/255.0, alpha: 1.0)
let secondaryBlueColor = UIColor(red: 10.0/255.0, green: 73.0/255.0, blue: 123.0/255.0, alpha: 1.0)
let mainWhiteColor = UIColor(red: 0.0/255.0, green: 49.0/255.0, blue: 83.0/255.0, alpha: 1.0)
let backgroundColor = UIColor(red: 0.0/255.0, green: 149.0/255.0, blue: 107.0/255.0, alpha: 1.0)
let correctAnswerColorGreen = UIColor(red: 122.0/255.0, green: 199.0/255.0, blue: 79.0/255.0, alpha: 1.0)
let wrongAnswerColorRed = UIColor(red: 255.0/255.0, green: 109.0/255.0, blue: 107.0/255.0, alpha: 1.0)



// MARK: - Tamaño de pantalla

let fullHeightScreen = UIScreen.main.bounds.height
let fullWidthScreen = UIScreen.main.bounds.width

func getStatusBarHeight () -> CGFloat {
    let window = UIApplication.shared.windows.filter {$0.isKeyWindow}.first
    return window?.windowScene?.statusBarManager?.statusBarFrame.height ?? 0.0
}

func getNavBarHeight (navigationController : UINavigationController) -> CGFloat {
    return navigationController.navigationBar.frame.height
}

func getTopBarHeight (statusBarHeight : CGFloat, navBarHeight : CGFloat) -> CGFloat {
    return statusBarHeight + navBarHeight
}

func getTabBarHeight (tabBarController : UITabBarController) -> CGFloat {
    return tabBarController.tabBar.frame.size.height
}


// MARK: Porcentaje elementos





var pruebaTemario = 343
// Nombres y variables de temarios
var chaptersNumber : [String] = ["Tema 1", "Tema 2", "Tema 3", "Tema 4", "Tema 5", "Tema 6", "Tema 7", "Tema 8", "Tema 9", "Tema 10", "Tema 11"]
var chaptersName : [String] = ["Nomenclatura náutica", "Elementos de amarre y fondeo", "Seguridad en el mar", "Legislación",
                               "Balizamiento", "Reglamento RIPA", "Maniobra", "Emergencias en la mar", "Meteorología",
                               "Teoría de navegación", "Carta náutica"]
var fullChapters : [String] = ["Tema 1: Nomenclatura náutica", "Tema 2: Elementos de amarre y fondeo", "Tema 3: Seguridad en el mar", "Tema 4: Legislación", "Tema 5: Balizamiento", "Tema 6: Reglamento RIPA", "Tema 7: Maniobra", "Tema 8: Emergencias en la mar", "Tema 9: Meteorología", "Tema 10: Teoría de navegación", "Tema 11: Carta náutica"]

// Nombres y variables de examen real
var optionExamName : [String] = ["Simulación de examen real"]
var optionExamImage : [String] = ["cabo"]
var optionChaptersImage : [String] = ["chpt_1", "chpt_2", "chpt_3", "chpt_1", "chpt_2", "chpt_3", "chpt_1", "chpt_2", "chpt_3", "chpt_1", "chpt_2"]


// Datos
let players : [String] = ["Total de exámenes", "Aprobados", "Suspensos"]
var goals : [Double] = []










// Configuración del diseño de navigation bar
func setDesignNavBar (navigationItem : UINavigationItem, appearance : UINavigationBarAppearance) {
    let appearance = UINavigationBarAppearance()
    appearance.configureWithOpaqueBackground()
    appearance.backgroundColor = mainBlueColor
    appearance.titleTextAttributes = [.foregroundColor: UIColor.white, NSAttributedString.Key.font: UIFont(name: "IBMPlexSans-Medium", size: 18)!]
    navigationItem.standardAppearance = appearance
    navigationItem.scrollEdgeAppearance = appearance
    navigationItem.compactAppearance = appearance
}


// Firebase
var ref : DatabaseReference!

// SQLite
public var databaseG : Connection!

// Tabla de preguntas
let questionsTable = Table("Preguntas")
let id_question = Expression<Int>("id_pregunta")
let chapter = Expression<String>("temario")
let question = Expression<String>("pregunta")
let answer_1 = Expression<String>("respuesta_1")
let answer_2 = Expression<String>("respuesta_2")
let answer_3 = Expression<String>("respuesta_3")
let answer_4 = Expression<String>("respuesta_4")
let correct_answer = Expression<Int>("respuesta_correcta")

// Tabla de historial
let historyTable = Table("Exámenes")
let id_exam = Expression<Int>("id_examen")
let chapter_exam = Expression<String>("temario")
let number_questions = Expression<Int>("num_preguntas")
let correctQuestions = Expression<Int>("aciertos")
let wrongQuestions = Expression<Int>("fallos")
let isApproved = Expression<Bool>("aprobado")

// MARK: Methods BBDD of questions

func createBBDDLocalSQLite () {
    print(" ====>>  Creación de la BASE DE DATOS  <<====")
    do {
        let documentDirectory = try FileManager.default.url(for: .documentDirectory, in: .userDomainMask, appropriateFor: nil, create: true)
        let fileURL = documentDirectory.appendingPathComponent("Preguntas").appendingPathExtension("sqlite3")
        let database = try Connection(fileURL.path)
        databaseG = database
        print (" --- DOCUMENT_DIRECTORY ... \(documentDirectory)")
    } catch {
        print (error)
    }
}

func createQuestionsTableSQLite () {
    print(" ====>>  Creación de la tabla de PREGUNTAS  <<====")
    do {
        _ = try databaseG.scalar(questionsTable.exists)
        print ("SÍ EXISTE ESTA TABLA. NO HAY NADA QUE CREAR")
    } catch {
        print ("NO EXISTE LA TABLA. HAY QUE CREARLA")
        let createTable = questionsTable.create { (table) in
            table.column(id_question, primaryKey : true)
            table.column(chapter)
            table.column(question, unique: true)
            table.column(answer_1)
            table.column(answer_2)
            table.column(answer_3)
            table.column(answer_4)
            table.column(correct_answer)
        }
        do {
            try databaseG.run(createTable)
            print ("¡Tabla creada! Compruébalo con la app BD Browser for SQLite :)")
        } catch {
            print (error)
        }
    }
}

func createTestsTableSQLite () {
    print(" ====>>  Creación de la tabla de EXÁMENES  <<====")
    do {
        _ = try databaseG.scalar(historyTable.exists)
        print ("SÍ EXISTE ESTA TABLA. NO HAY NADA QUE CREAR")
    } catch {
        print ("NO EXISTE LA TABLA. HAY QUE CREARLA")
        let createTable = historyTable.create { (table) in
            table.column(id_exam, primaryKey : true)
            table.column(chapter_exam)
            table.column(number_questions)
            table.column(correctQuestions)
            table.column(wrongQuestions)
            table.column(isApproved)
        }
        do {
            try databaseG.run(createTable)
            print ("¡Tabla creada! Compruébalo con la app BD Browser for SQLite :)")
        } catch {
            print (error)
        }
    }
}

func getQuestionsFromFirebaseToSQLite () {
    do {
        let numberOfRows : Int = try databaseG.scalar(questionsTable.count)
        print (" ......................................")
        print (" --- Número de preguntas insertadas: \(numberOfRows)")
        if (numberOfRows == 0) {
            print ("¡¡¡SE INTRODUCEN TODOS LOS DATOS!!!")
            ref = Database.database().reference()
            
            ref.observe(.value, with: { (snapshot: DataSnapshot!) in

                for i in 1 ... snapshot.childrenCount {
                    
                    ref.child("Pregunta_\(i)").observeSingleEvent(of: .value, with: { (snapshot) in
                        
                        // Get question values
                        
                        let value = snapshot.value as? NSDictionary
                               
                        let id_pregunta = value?["id_pregunta"] as? Int
                        let temario = value?["temario"] as? String
                        let pregunta = value?["pregunta"] as? String
                        let respuesta_1 = value?["respuesta_1"] as? String
                        let respuesta_2 = value?["respuesta_2"] as? String
                        let respuesta_3 = value?["respuesta_3"] as? String
                        let respuesta_4 = value?["respuesta_4"] as? String
                        let respuesta_correcta = value?["respuesta_correcta"] as? Int
                               
                        let insertQuestion = questionsTable.insert(id_question <- id_pregunta!, chapter <- temario!, question <- pregunta!, answer_1 <- respuesta_1!, answer_2 <- respuesta_2!, answer_3 <- respuesta_3!, answer_4 <- respuesta_4!, correct_answer <- respuesta_correcta!)
                               
                        do {
                            try databaseG.run(insertQuestion)
                            print ("¡Pregunta insertada! Compruébalo con la app BD Browser for SQLite :)")
                        } catch {
                            print (error)
                        }
                               
                    }) { (error) in
                        print(error.localizedDescription)
                    }
                }
            })
        } else {
            print ("NO SE INTRODUCEN LOS DATOS. Ya están los datos dentro de la BBDD de SQLITE")
            // Cuando es igual a 0, el caso del if, se añaden todos los datos.
            // Cuando no es igual a 0, se hacen las comprobaciones para la pertinente actualización (si es que es necesario, claro).
            // No es lógico que cada vez que el usuario abra la aplicación se produzca toooooda la carga de los datos cuando realmente son los mismos.
        }
    } catch {
        print (error)
    }
}



func get10QuestionsForTest (nameChapter : String) -> [Question] {
    var questions : [Question] = []
    do {
        for row in try databaseG.prepare("SELECT DISTINCT * FROM Preguntas WHERE temario = '\(nameChapter)' ORDER BY RANDOM () LIMIT 10") {
            //
            let id : Int = Int(Optional(row[0]) as! Int64)
            let chapter : String? = row[1] as? String
            let question : String? = row[2] as? String
            let answer1 : String? = row[3] as? String
            let answer2 : String? = row[4] as? String
            let answer3 : String? = row[5] as? String
            let answer4 : String? = row[6] as? String
            let correctAns : Int = Int(Optional(row[7]) as! Int64)
            //
            let questionToInsert = Question(id: id, chapter: chapter!, question: question!, answer1: answer1!, answer2: answer2!, answer3: answer3!, answer4: answer4!, correctAnswer: correctAns)
            //
            questions.append(questionToInsert)
        }
        // print (" ::::::::::::: \(questions.count)")
    } catch {   print (error)   }
    return questions
}


func getQuestionsForSimulation () -> [Question] {
    var questions : [Question] = []
    do {
        for i in 0 ... 10 {
            
            let number : Int
            if (i == 0) { number = 4 }
            else if (i == 1) { number = 2 }
            else if (i == 2) { number = 4 }
            else if (i == 3) { number = 2 }
            else if (i == 4) { number = 5 }
            else if (i == 5) { number = 10 }
            else if (i == 6) { number = 2 }
            else if (i == 7) { number = 3 }
            else if (i == 8) { number = 4 }
            else if (i == 9) { number = 5 }
            else { number =  4 }
            
            for row in try databaseG.prepare("SELECT DISTINCT * FROM Preguntas WHERE temario = '\(chaptersName[i])' ORDER BY RANDOM () LIMIT \(number)") {
                //
                let id : Int = Int(Optional(row[0]) as! Int64)
                let chapter : String? = row[1] as? String
                let question : String? = row[2] as? String
                let answer1 : String? = row[3] as? String
                let answer2 : String? = row[4] as? String
                let answer3 : String? = row[5] as? String
                let answer4 : String? = row[6] as? String
                let correctAns : Int = Int(Optional(row[7]) as! Int64)
                //
                let questionToInsert = Question(id: id, chapter: chapter!, question: question!, answer1: answer1!, answer2: answer2!, answer3: answer3!, answer4: answer4!, correctAnswer: correctAns)
                //
                questions.append(questionToInsert)
                //
                print (" == >> chapter: \(chapter!)")
            }
            print (" ::::::::::::: \(questions.count)")
        }
        // print (" ::::::::::::: \(questions.count)")
    } catch {   print (error)   }
    return questions
}

func removeHistoryOfChapter (chapter : String) {
    let exams = historyTable.filter(chapter_exam == chapter)
    do {
        print (try databaseG.scalar(historyTable.count))
        try databaseG.run(exams.delete())
        print (try databaseG.scalar(historyTable.count))
    } catch {
        print (error)
    }
}

func removeAllHistory () {
    do {
        print (try databaseG.scalar(historyTable.count))
        try databaseG.run(historyTable.delete())
        print (try databaseG.scalar(historyTable.count))
    } catch {
        print (error)
    }
}

func feedBackRemoveData (chapter : String) -> UIAlertController {
    let alert = UIAlertController(title: "¡Perfecto!", message: "\n \(chapter)", preferredStyle: .alert)
    let actionOk = UIAlertAction(title: "OK", style: .default, handler: nil)
    alert.addAction(actionOk)
    return alert
}



